#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "sysmain.h"
#include "thingdef.h"
#include "resource.h"
#include "map.h"
#include "specname.h"
#include "doomdata.h"
#include "wcm.h"

void AddTextureStrings(HWND hDropDownList, int sel, BOOL extra)
{
    int     i;
    char    name[20], desc[12];

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    if (extra)
    {
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)"-");
        sel++;
    }

    for (i= 0 ; i<numtextures ; i++)
    {
        name[8] = 0;
        strncpy(name, textures[i]->name, 8);
        sprintf(desc, " (%dx%d)", textures[i]->width, textures[i]->height);
        strcat(name, desc);
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)name);
    }

    SendMessage(hDropDownList, CB_SETCURSEL, sel, 0);
}

void DrawTexture(HWND hPicBox, int i)
{
    void*   pBits;
    HDC     hdc;

    // wi
    InvalidateRect(hPicBox, NULL, TRUE);
    UpdateWindow(hPicBox);

    if (i == -1)
        return;

    TextureToBitmap(textures[i], pbmi, &pBits);

    hdc = GetDC(hPicBox);
    SetDIBitsToDevice(hdc, 0, 0, textures[i]->width, textures[i]->height, 0, 0, 0, textures[i]->height, pBits, pbmi, DIB_RGB_COLORS);
    ReleaseDC(hPicBox, hdc);

    free(pBits);
}

BOOL CALLBACK DefTexDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT        rect;
    int         w, h;
    int         i;
    static HWND hPicBox1, hPicBox2, hPicBox3, hDropDownList1, hDropDownList2, hDropDownList3;

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        hPicBox1 = GetDlgItem(hDlg, IDC_PICBOX1);
        hPicBox2 = GetDlgItem(hDlg, IDC_PICBOX2);
        hPicBox3 = GetDlgItem(hDlg, IDC_PICBOX3);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        hDropDownList2 = GetDlgItem(hDlg, IDC_DROPDOWNLIST2);
        hDropDownList3 = GetDlgItem(hDlg, IDC_DROPDOWNLIST3);
        i = GetTextureNumForName(defupptexture);
        AddTextureStrings(hDropDownList1, i, FALSE);
        i = GetTextureNumForName(defmidtexture);
        AddTextureStrings(hDropDownList2, i, FALSE);
        i = GetTextureNumForName(deflowtexture);
        AddTextureStrings(hDropDownList3, i, FALSE);
        return TRUE;

    case WM_CTLCOLORDLG:
        // WM_INITDIALOGnhł͑邹ʖ
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST1, CBN_SELCHANGE), (LPARAM)hDropDownList1);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST2, CBN_SELCHANGE), (LPARAM)hDropDownList2);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST3, CBN_SELCHANGE), (LPARAM)hDropDownList3);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            strncpy(defupptexture, textures[i]->name, 8);
            i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
            strncpy(defmidtexture, textures[i]->name, 8);
            i = SendMessage(hDropDownList3, CB_GETCURSEL, 0, 0);
            strncpy(deflowtexture, textures[i]->name, 8);
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_DROPDOWNLIST1:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
                DrawTexture(hPicBox1, i);
            }
            return TRUE;

        case IDC_DROPDOWNLIST2:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
                DrawTexture(hPicBox2, i);
            }
            return TRUE;

        case IDC_DROPDOWNLIST3:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList3, CB_GETCURSEL, 0, 0);
                DrawTexture(hPicBox3, i);
            }
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

void AddFlatStrings(HWND hDropDownList, int sel)
{
    int     i;
    char    name[9];

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    name[8] = 0;
    for (i= 0 ; i<numflats ; i++)
    {
        strncpy(name, flatnames[i], 8);
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)name);
    }

    SendMessage(hDropDownList, CB_SETCURSEL, sel, 0);
}

void DrawFlat(HWND hPicBox, int i)
{
    HDC     hdc;

    pbmi->bmiHeader.biWidth = 64;
    pbmi->bmiHeader.biHeight = -64;

    InvalidateRect(hPicBox, NULL, TRUE);
    UpdateWindow(hPicBox);

    hdc = GetDC(hPicBox);
    SetDIBitsToDevice(hdc, 0, 0, 64, 64, 0, 0, 0, 64, flats[i], pbmi, DIB_RGB_COLORS);
    ReleaseDC(hPicBox, hdc);
}

BOOL CALLBACK DefSecDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT        rect;
    int         w, h;
    int         i;
    BOOL        bTran;
    static HWND hPicBox1, hPicBox2, hDropDownList1, hDropDownList2;

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        hPicBox1 = GetDlgItem(hDlg, IDC_PICBOX1);
        hPicBox2 = GetDlgItem(hDlg, IDC_PICBOX2);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        hDropDownList2 = GetDlgItem(hDlg, IDC_DROPDOWNLIST2);
        i = GetFlatNumForName(defsecstate.floorflat);
        AddFlatStrings(hDropDownList1, i);
        i = GetFlatNumForName(defsecstate.ceilingflat);
        AddFlatStrings(hDropDownList2, i);
        SetDlgItemInt(hDlg, IDC_EDITBOX1, defsecstate.floorheight, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX2, defsecstate.ceilingheight, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX3, defsecstate.lightlevel, TRUE);
        return TRUE;

    case WM_CTLCOLORDLG:
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST1, CBN_SELCHANGE), (LPARAM)hDropDownList1);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST2, CBN_SELCHANGE), (LPARAM)hDropDownList2);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            strncpy(defsecstate.floorflat, flatnames[i], 8);
            i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
            strncpy(defsecstate.ceilingflat, flatnames[i], 8);
            defsecstate.floorheight = GetDlgItemInt(hDlg, IDC_EDITBOX1, &bTran, TRUE);
            defsecstate.ceilingheight = GetDlgItemInt(hDlg, IDC_EDITBOX2, &bTran, TRUE);
            defsecstate.lightlevel = GetDlgItemInt(hDlg, IDC_EDITBOX3, &bTran, TRUE);
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_DROPDOWNLIST1:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
                DrawFlat(hPicBox1, i);
            }
            return TRUE;

        case IDC_DROPDOWNLIST2:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
                DrawFlat(hPicBox2, i);
            }
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

void AddLineSpecialStrings(HWND hDropDownList, int sel)
{
    int i, numspecials;

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    numspecials = GetNumLineSpecials();
    for (i=0 ; i<numspecials ; i++)
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)linespecnames[i]);

    SendMessage(hDropDownList, CB_SETCURSEL, sel, 0);
}

const RECT tabrect = {152, 0, 420, 310};
int sideoffsets[2][2];
int sidetextures[2][3];

BOOL CALLBACK LineEditDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT                rect;
    int                 w, h;
    int                 i;
    BOOL                bTran;
    static HWND         hTabCtrl;
    TC_ITEM             item;
    static int          tab;
    static HWND         hDropDownList1, hDropDownList2, hDropDownList3, hDropDownList4;
    static HWND         hPicBox1, hPicBox2, hPicBox3;
    static linedef_t*   line;

    HDC                 hdc;
    static const RECT   st3rect = {162, 23, 192, 33};
    static const RECT   st4rect = {244, 23, 274, 33};
    static const RECT   st5rect = {320, 45, 410, 55};
    static const RECT   st6rect = {320, 133, 410, 143};
    static const RECT   st7rect = {320, 221, 410, 231};

    switch (message)
    {
    case WM_INITDIALOG:
        line = (linedef_t *)selected.ptr;
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        CheckDlgButton(hDlg, IDC_CHECKBOX1, line->flags & ML_BLOCKING);
        CheckDlgButton(hDlg, IDC_CHECKBOX2, line->flags & ML_BLOCKMONSTERS);
        CheckDlgButton(hDlg, IDC_CHECKBOX3, line->flags & ML_TWOSIDED);
        CheckDlgButton(hDlg, IDC_CHECKBOX4, line->flags & ML_DONTPEGTOP);
        CheckDlgButton(hDlg, IDC_CHECKBOX5, line->flags & ML_DONTPEGBOTTOM);
        CheckDlgButton(hDlg, IDC_CHECKBOX6, line->flags & ML_SECRET);
        CheckDlgButton(hDlg, IDC_CHECKBOX7, line->flags & ML_SOUNDBLOCK);
        CheckDlgButton(hDlg, IDC_CHECKBOX8, line->flags & ML_DONTDRAW);
        CheckDlgButton(hDlg, IDC_CHECKBOX9, line->flags & ML_MAPPED);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        AddLineSpecialStrings(hDropDownList1, line->special);
        SetDlgItemInt(hDlg, IDC_EDITBOX1, line->tag, TRUE);
        rect = tabrect;
        MapDialogRect(hDlg, &rect);
        hTabCtrl = CreateWindowEx(0, WC_TABCONTROL, "", WS_CHILD | WS_VISIBLE /*| TCS_BUTTONS*/ | TCS_FOCUSNEVER,
                                  rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top,
                                  hDlg, (HMENU)IDC_TABCTRL, hInst, NULL);
        SendMessage(hTabCtrl, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), 0);
        ZeroMemory(&item, sizeof(TC_ITEM));
        item.mask = TCIF_TEXT;
        item.pszText = "Right Sidedef";
        TabCtrl_InsertItem(hTabCtrl, 0, &item);
        sideoffsets[0][0] = line->sides[0].xoffset;
        sideoffsets[0][1] = line->sides[0].yoffset;
        sidetextures[0][0] = GetTextureNumForName(line->sides[0].upper);
        sidetextures[0][1] = GetTextureNumForName(line->sides[0].middle);
        sidetextures[0][2] = GetTextureNumForName(line->sides[0].lower);
        if (line->sides[1].sec)
        {
            item.pszText = "Left Sidedef";
            TabCtrl_InsertItem(hTabCtrl, 1, &item);
            sideoffsets[1][0] = line->sides[1].xoffset;
            sideoffsets[1][1] = line->sides[1].yoffset;
            sidetextures[1][0] = GetTextureNumForName(line->sides[1].upper);
            sidetextures[1][1] = GetTextureNumForName(line->sides[1].middle);
            sidetextures[1][2] = GetTextureNumForName(line->sides[1].lower);
        }
        tab = 0;   //  0 ɂ̂YƑO tab ̒l 1 ꍇAsideoffsets[1][*]  sidetextures[1][*]  [0][*] ̒lĂ܂
        SetDlgItemInt(hDlg, IDC_EDITBOX2, sideoffsets[0][0], TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX3, sideoffsets[0][1], TRUE);
        hDropDownList2 = GetDlgItem(hDlg, IDC_DROPDOWNLIST2);
        hDropDownList3 = GetDlgItem(hDlg, IDC_DROPDOWNLIST3);
        hDropDownList4 = GetDlgItem(hDlg, IDC_DROPDOWNLIST4);
        AddTextureStrings(hDropDownList2, sidetextures[0][0], TRUE);
        AddTextureStrings(hDropDownList3, sidetextures[0][1], TRUE);
        AddTextureStrings(hDropDownList4, sidetextures[0][2], TRUE);
        hPicBox1 = GetDlgItem(hDlg, IDC_PICBOX1);
        hPicBox2 = GetDlgItem(hDlg, IDC_PICBOX2);
        hPicBox3 = GetDlgItem(hDlg, IDC_PICBOX3);
        return TRUE;

    case WM_CTLCOLORDLG:
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST2, CBN_SELCHANGE), (LPARAM)hDropDownList2);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST3, CBN_SELCHANGE), (LPARAM)hDropDownList3);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST4, CBN_SELCHANGE), (LPARAM)hDropDownList4);
        PostMessage(hDlg, WM_APP, 0, 0);
        return TRUE;

    case WM_APP:
        hdc = GetDC(hDlg);
        SetBkMode(hdc, TRANSPARENT);
        SelectObject(hdc, GetStockObject(DEFAULT_GUI_FONT));
        rect = st3rect;
        MapDialogRect(hDlg, &rect);
        DrawText(hdc, "X offset", -1, &rect, 0);
        rect = st4rect;
        MapDialogRect(hDlg, &rect);
        DrawText(hdc, "Y offset", -1, &rect, 0);
        rect = st5rect;
        MapDialogRect(hDlg, &rect);
        DrawText(hdc, "Upper Texture", -1, &rect, 0);
        rect = st6rect;
        MapDialogRect(hDlg, &rect);
        DrawText(hdc, "Middle Texture", -1, &rect, 0);
        rect = st7rect;
        MapDialogRect(hDlg, &rect);
        DrawText(hdc, "Lower Texture", -1, &rect, 0);
        ReleaseDC(hDlg, hdc);
        return TRUE;

    case WM_NOTIFY:
        if (((NMHDR*)lParam)->code == TCN_SELCHANGE)
        {
            tab = TabCtrl_GetCurSel(hTabCtrl);
            SetDlgItemInt(hDlg, IDC_EDITBOX2, sideoffsets[tab][0], TRUE);
            SetDlgItemInt(hDlg, IDC_EDITBOX3, sideoffsets[tab][1], TRUE);
            SendMessage(hDropDownList2, CB_SETCURSEL, sidetextures[tab][0]+1, 0);
            SendMessage(hDropDownList3, CB_SETCURSEL, sidetextures[tab][1]+1, 0);
            SendMessage(hDropDownList4, CB_SETCURSEL, sidetextures[tab][2]+1, 0);
            SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST2, CBN_SELCHANGE), (LPARAM)hDropDownList2);
            SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST3, CBN_SELCHANGE), (LPARAM)hDropDownList3);
            SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST4, CBN_SELCHANGE), (LPARAM)hDropDownList4);
        }
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            line->flags = 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX1) ? ML_BLOCKING : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX2) ? ML_BLOCKMONSTERS : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX3) ? ML_TWOSIDED : 0; // ProcessLineSideDefs()[savebsp.cpp]ŎIɐݒ肳̂Ŏ͂Kv͖
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX4) ? ML_DONTPEGTOP : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX5) ? ML_DONTPEGBOTTOM : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX6) ? ML_SECRET : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX7) ? ML_SOUNDBLOCK : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX8) ? ML_DONTDRAW : 0;
            line->flags |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX9) ? ML_MAPPED : 0;
            line->special = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            line->tag = GetDlgItemInt(hDlg, IDC_EDITBOX1, &bTran, TRUE);
            line->sides[0].xoffset = sideoffsets[0][0];
            line->sides[0].yoffset = sideoffsets[0][1];
            strncpy(line->sides[0].upper, GetTextureNameForNum(sidetextures[0][0]), 8);
            strncpy(line->sides[0].middle, GetTextureNameForNum(sidetextures[0][1]), 8);
            strncpy(line->sides[0].lower, GetTextureNameForNum(sidetextures[0][2]), 8);
            if (line->sides[1].sec)
            {
                line->sides[1].xoffset = sideoffsets[1][0];
                line->sides[1].yoffset = sideoffsets[1][1];
                strncpy(line->sides[1].upper, GetTextureNameForNum(sidetextures[1][0]), 8);
                strncpy(line->sides[1].middle, GetTextureNameForNum(sidetextures[1][1]), 8);
                strncpy(line->sides[1].lower, GetTextureNameForNum(sidetextures[1][2]), 8);
            }
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_EDITBOX2:
            if (HIWORD(wParam) == EN_CHANGE)
            {
                i = GetDlgItemInt(hDlg, IDC_EDITBOX2, &bTran, TRUE);
                sideoffsets[tab][0] = i;
            }
            return TRUE;

        case IDC_EDITBOX3:
            if (HIWORD(wParam) == EN_CHANGE)
            {
                i = GetDlgItemInt(hDlg, IDC_EDITBOX3, &bTran, TRUE);
                sideoffsets[tab][1] = i;
            }
            return TRUE;

        case IDC_DROPDOWNLIST2:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
                i--;
                DrawTexture(hPicBox1, i);
                sidetextures[tab][0] = i;
            }
            return TRUE;

        case IDC_DROPDOWNLIST3:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList3, CB_GETCURSEL, 0, 0);
                i--;
                DrawTexture(hPicBox2, i);
                sidetextures[tab][1] = i;
            }
            return TRUE;

        case IDC_DROPDOWNLIST4:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList4, CB_GETCURSEL, 0, 0);
                i--;
                DrawTexture(hPicBox3, i);
                sidetextures[tab][2] = i;
            }
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

void AddSecSpecialStrings(HWND hDropDownList, int sel)
{
    int i;

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    for (i=0 ; i<18 ; i++)
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)secspecnames[i]);

    SendMessage(hDropDownList, CB_SETCURSEL, sel, 0);
}

void ChangeUppLowTextures(sector_t* sec, int floorheight, int ceilingheight)
{
    linedef_t*  line;
    int         oppside;

    if (sec->floorheight != floorheight)
    {
        for (line = firstlinedef.next ; line ; line = line->next)
        {
            if (line->sides[0].sec == sec && line->sides[1].sec)
                oppside = 1;
            else if (line->sides[1].sec == sec)
                oppside = 0;
            else
                continue;

            if (line->sides[oppside].sec->floorheight > floorheight && line->sides[oppside].sec->floorheight <= sec->floorheight)
            {
                memcpy(line->sides[!oppside/*oppside^1*/].lower, deflowtexture, 8);
                strcpy(line->sides[oppside].lower, "-");
            }
            else if (line->sides[oppside].sec->floorheight < floorheight && line->sides[oppside].sec->floorheight >= sec->floorheight)
            {
                memcpy(line->sides[oppside].lower, deflowtexture, 8);
                strcpy(line->sides[!oppside].lower, "-");
            }
            else if (line->sides[oppside].sec->floorheight == floorheight)
            {
                strcpy(line->sides[0].lower, "-");
                strcpy(line->sides[1].lower, "-");
            }
        }
        sec->floorheight = floorheight;
    }

    if (sec->ceilingheight != ceilingheight)
    {
        for (line = firstlinedef.next ; line ; line = line->next)
        {
            if (line->sides[0].sec == sec && line->sides[1].sec)
                oppside = 1;
            else if (line->sides[1].sec == sec)
                oppside = 0;
            else
                continue;

            if (line->sides[oppside].sec->ceilingheight > ceilingheight && line->sides[oppside].sec->ceilingheight <= sec->ceilingheight)
            {
                memcpy(line->sides[oppside].upper, defupptexture, 8);
                strcpy(line->sides[!oppside].upper, "-");
            }
            else if (line->sides[oppside].sec->ceilingheight < ceilingheight && line->sides[oppside].sec->ceilingheight >= sec->ceilingheight)
            {
                memcpy(line->sides[!oppside].upper, defupptexture, 8);
                strcpy(line->sides[oppside].upper, "-");
            }
            else if (line->sides[oppside].sec->ceilingheight == ceilingheight)
            {
                strcpy(line->sides[0].upper, "-");
                strcpy(line->sides[1].upper, "-");
            }
        }
        sec->ceilingheight = ceilingheight;
    }
}

BOOL CALLBACK SecEditDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT                rect;
    int                 w, h, i;
    BOOL                bTran;
    static HWND         hPicBox1, hPicBox2, hDropDownList1, hDropDownList2, hDropDownList3;
    static sector_t*    sec;

    switch (message)
    {
    case WM_INITDIALOG:
        sec = (sector_t *)selected.ptr;
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX1, sec->floorheight, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX2, sec->ceilingheight, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX3, sec->lightlevel, TRUE);
        SetDlgItemInt(hDlg, IDC_EDITBOX4, sec->tag, TRUE);
        hPicBox1 = GetDlgItem(hDlg, IDC_PICBOX1);
        hPicBox2 = GetDlgItem(hDlg, IDC_PICBOX2);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        hDropDownList2 = GetDlgItem(hDlg, IDC_DROPDOWNLIST2);
        i = GetFlatNumForName(sec->floorflat);
        AddFlatStrings(hDropDownList1, i);
        i = GetFlatNumForName(sec->ceilingflat);
        AddFlatStrings(hDropDownList2, i);
        hDropDownList3 = GetDlgItem(hDlg, IDC_DROPDOWNLIST3);
        AddSecSpecialStrings(hDropDownList3, sec->special);
        return TRUE;

    case WM_CTLCOLORDLG:
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST1, CBN_SELCHANGE), (LPARAM)hDropDownList1);
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_DROPDOWNLIST2, CBN_SELCHANGE), (LPARAM)hDropDownList2);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            ChangeUppLowTextures(sec, GetDlgItemInt(hDlg, IDC_EDITBOX1, &bTran, TRUE), GetDlgItemInt(hDlg, IDC_EDITBOX2, &bTran, TRUE));
            i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            strncpy(sec->floorflat, flatnames[i], 8);
            i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
            strncpy(sec->ceilingflat, flatnames[i], 8);
            sec->lightlevel = GetDlgItemInt(hDlg, IDC_EDITBOX3, &bTran, TRUE);
            sec->special = SendMessage(hDropDownList3, CB_GETCURSEL, 0, 0);
            sec->tag = GetDlgItemInt(hDlg, IDC_EDITBOX4, &bTran, TRUE);
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_DROPDOWNLIST1:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
                DrawFlat(hPicBox1, i);
            }
            return TRUE;

        case IDC_DROPDOWNLIST2:
            if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_CLOSEUP)
            {
                i = SendMessage(hDropDownList2, CB_GETCURSEL, 0, 0);
                DrawFlat(hPicBox2, i);
            }
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

void DrawSprite(HWND hPicBox, int i)
{
    void*       pBits;
    HDC         hdc;
    PBITMAPINFO lpbmi;

    InvalidateRect(hPicBox, NULL, TRUE);
    UpdateWindow(hPicBox);

    if (!thingdefs[i].spritedata)
        return;

    switch (thingdefs[i].type)
    {
    case 2:
        lpbmi = pbmi2;
        break;
    case 3:
        lpbmi = pbmi3;
        break;
    case 4:
        lpbmi = pbmi4;
        break;
    case 58:
        lpbmi = pbmi5;
        break;
    default:
        lpbmi = pbmi;
    }
    PatchToBitmap(thingdefs[i].spritedata, lpbmi, &pBits);

    hdc = GetDC(hPicBox);
    SetDIBitsToDevice(hdc, 0, 0, thingdefs[i].spritedata->width, thingdefs[i].spritedata->height, 0, 0, 0, thingdefs[i].spritedata->height, pBits, lpbmi, DIB_RGB_COLORS);
    ReleaseDC(hPicBox, hdc);

    free(pBits);
}

char* anglenames[] =
{
    "0 (east)",
    "45 (northeast)",
    "90 (north)",
    "135 (northwest)",
    "180 (west)",
    "225 (southwest)",
    "270 (south)",
    "315 (southeast)"
};

void AddAngleStrings(HWND hDropDownList, int sel)
{
    int i;

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    for (i=0 ; i<8 ; i++)
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)anglenames[i]);

    SendMessage(hDropDownList, CB_SETCURSEL, sel, 0);
}

const RECT buttonrect = {10, 106, 50, 120};

BOOL CALLBACK ThingEditDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT                rect;
    int                 w, h, i;
    POINT               pt;
    static int          numthingdefs;
    int                 id;
    static int          lastsel;
    static HWND         hPicBox1, hDropDownList1;
    static thing_t*     thing;

    switch (message)
    {
    case WM_INITDIALOG:
        thing = (thing_t *)selected.ptr;
        numthingdefs = GetNumThingdefs();
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        hPicBox1 = GetDlgItem(hDlg, IDC_PICBOX1);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        AddAngleStrings(hDropDownList1, thing->angle/45);
        CheckDlgButton(hDlg, IDC_CHECKBOX1, thing->options & 1);
        CheckDlgButton(hDlg, IDC_CHECKBOX2, thing->options & 2);
        CheckDlgButton(hDlg, IDC_CHECKBOX3, thing->options & 4);
        CheckDlgButton(hDlg, IDC_CHECKBOX4, thing->options & 8);
        CheckDlgButton(hDlg, IDC_CHECKBOX5, thing->options & 16);
        lastsel = thing->id;
        return TRUE;

    case WM_CTLCOLORDLG: // o[W6̃RRg[gƏ񎞈ȊOɂx
        PostMessage(hDlg, WM_COMMAND, MAKEWPARAM(lastsel/*thing->id*/, 0), 0);
        return TRUE;

    case WM_COMMAND:
        id = LOWORD(wParam);
        if (id >= 0 && id < numthingdefs)
        {
            SetDlgItemText(hDlg, IDC_STEXT1, thingdefs[id].description);
            DrawSprite(hPicBox1, id);
            lastsel = id;
            return TRUE;
        }
        switch(id)
        {
        case IDC_OK:
            thing->id = lastsel;
            thing->type = thingdefs[lastsel].type;
            i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            thing->angle = i*45;
            thing->options = 0;
            thing->options |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX1) ? 1 : 0;
            thing->options |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX2) ? 2 : 0;
            thing->options |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX3) ? 4 : 0;
            thing->options |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX4) ? 8 : 0;
            thing->options |= IsDlgButtonChecked(hDlg, IDC_CHECKBOX5) ? 16 : 0;
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_CANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_PUSHBUTTON:
            rect = buttonrect;
            MapDialogRect(hDlg, &rect);
            pt.x = rect.right;
            pt.y = rect.top;
            ClientToScreen(hDlg, &pt);
            TrackPopupMenu(hThingMenu, 0, pt.x, pt.y, 0, hDlg, NULL);
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

char* mapnames[] =
{
    "MAP01", "MAP02", "MAP03", "MAP04", "MAP05", "MAP06", "MAP07", "MAP08",
    "MAP09", "MAP10", "MAP11", "MAP12", "MAP13", "MAP14", "MAP15", "MAP16",
    "MAP17", "MAP18", "MAP19", "MAP20", "MAP21", "MAP22", "MAP23", "MAP24",
    "MAP25", "MAP26", "MAP27", "MAP28", "MAP29", "MAP30", "MAP31", "MAP32"
};

void AddMapStrings(HWND hDropDownList)
{
    int i;

    SendMessage(hDropDownList, CB_RESETCONTENT, 0, 0);

    for (i=0 ; i<32 ; i++)
        SendMessage(hDropDownList, CB_ADDSTRING, 0, (LPARAM)mapnames[i]);

    SendMessage(hDropDownList, CB_SETCURSEL, 0, 0);
}

BOOL CALLBACK ChangeMapDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT        rect;
    int         w, h;
    static HWND hDropDownList1;
    int         i;

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        hDropDownList1 = GetDlgItem(hDlg, IDC_DROPDOWNLIST1);
        AddMapStrings(hDropDownList1);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            i = SendMessage(hDropDownList1, CB_GETCURSEL, 0, 0);
            gamemap = i + 1;
            UpdateTitleBar();
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

BOOL CALLBACK LocateGameDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT        rect;
    int         w, h;
    static char szFilter[] = "Q[st@C {*.exe}\0 *.exe\0\0";
    static char szFile[1024] = "";
    static char szFileTitle[256];
    static OPENFILENAME ofn;

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        if (!strcmp(gamefilename, "undesignated"))
            SetDlgItemText(hDlg, IDC_STEXT2, "w肳Ă܂");
        else
            SetDlgItemText(hDlg, IDC_STEXT2, gamefilename);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            GetDlgItemText(hDlg, IDC_STEXT2, gamefilename, 1024);
            if (!strcmp(gamefilename, "w肳Ă܂"))
                strcpy(gamefilename, "undesignated");
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_PUSHBUTTON:
            ZeroMemory(&ofn, sizeof(OPENFILENAME));
            ofn.lStructSize = sizeof(OPENFILENAME);
	        ofn.hwndOwner = hDlg;
            ofn.lpstrFilter = szFilter;
	        ofn.lpstrFile = szFile;
	        ofn.nMaxFile = 1024;
            ofn.lpstrFileTitle = szFileTitle;
	        ofn.nMaxFileTitle = 256;
	        ofn.lpstrDefExt = "exe";
            ofn.lpstrTitle = "Q[st@Cw";
	        ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
            if (GetOpenFileName(&ofn))
                SetDlgItemText(hDlg, IDC_STEXT2, szFile);
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

BOOL CheckParams(char* params) // 󔒕ȂFALSEԂ
{
    char* c;

    c = &params[0];
    while (*c)
    {
        if (*c != ' ' && *c != '\t')
            return TRUE;
        c++;
    }

    return FALSE;
}

BOOL CALLBACK PlayOptionDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT    rect;
    int     w, h;
    char    buf[256];

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        CheckDlgButton(hDlg, IDC_CHECKBOX1, nomonsters);
        CheckDlgButton(hDlg, IDC_CHECKBOX2, nomusic);
        if (strcmp(fileoptparms, "undesignated"))
            SetDlgItemText(hDlg, IDC_EDITBOX1, fileoptparms);
        if (strcmp(cmdlineparms, "undesignated"))
            SetDlgItemText(hDlg, IDC_EDITBOX2, cmdlineparms);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            nomonsters = IsDlgButtonChecked(hDlg, IDC_CHECKBOX1);
            nomusic = IsDlgButtonChecked(hDlg, IDC_CHECKBOX2);
            GetDlgItemText(hDlg, IDC_EDITBOX1, buf, 256);
            if (CheckParams(buf))
                strcpy(fileoptparms, buf);
            else
                strcpy(fileoptparms, "undesignated");
            GetDlgItemText(hDlg, IDC_EDITBOX2, buf, 256);
            if (CheckParams(buf))
                strcpy(cmdlineparms, buf);
            else
                strcpy(cmdlineparms, "undesignated");
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_PUSHBUTTON:
            nomonsters = IsDlgButtonChecked(hDlg, IDC_CHECKBOX1);
            nomusic = IsDlgButtonChecked(hDlg, IDC_CHECKBOX2);
            GetDlgItemText(hDlg, IDC_EDITBOX1, buf, 256);
            if (CheckParams(buf))
                strcpy(fileoptparms, buf);
            else
                strcpy(fileoptparms, "undesignated");
            GetDlgItemText(hDlg, IDC_EDITBOX2, buf, 256);
            if (CheckParams(buf))
                strcpy(cmdlineparms, buf);
            else
                strcpy(cmdlineparms, "undesignated");
            EndDialog(hDlg, 0);
            PostMessage(hMainWnd, WM_COMMAND, MAKEWPARAM(IDM_PLAY, 0), 0);
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

BOOL CALLBACK BuildOptionDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT    rect;
    int     w, h;

    switch (message)
    {
    case WM_INITDIALOG:
        GetWindowRect(hDlg, &rect);
        w = rect.right - rect.left;
        h = rect.bottom - rect.top;
        MoveWindow(hDlg, (cxscreen - w)/2, (cyscreen - h)/2, w, h, TRUE);
        CheckDlgButton(hDlg, IDC_CHECKBOX1, calcpvs);
        CheckDlgButton(hDlg, IDC_CHECKBOX2, debugout);
        return TRUE;

    case WM_COMMAND:
        switch(LOWORD(wParam))
        {
        case IDOK:
            calcpvs = IsDlgButtonChecked(hDlg, IDC_CHECKBOX1);
            debugout = IsDlgButtonChecked(hDlg, IDC_CHECKBOX2);
            EndDialog(hDlg, 0);
            return TRUE;

        case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;

        case IDC_PUSHBUTTON:
            calcpvs = IsDlgButtonChecked(hDlg, IDC_CHECKBOX1);
            debugout = IsDlgButtonChecked(hDlg, IDC_CHECKBOX2);
            EndDialog(hDlg, 0);
            PostMessage(hMainWnd, WM_COMMAND, MAKEWPARAM(IDM_BUILD, 0), 0);
            return TRUE;
        }
        return TRUE;
    }

    return FALSE;
}

void PrintDialog(char* str, HWND hDlg, int idc)
{
    SetDlgItemText(hDlg, idc, str);
    SetForegroundWindow(hDlg);
}
