#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include <math.h>
#include "map.h"
#include "sysmain.h"
#include "opengl.h"
#include "geometry.h"
#include "sysutils.h"
#include "thingdef.h"
#include "wcm.h"

int numsectors = 0;
int numlinedefs = 0;
int numvertices = 0;
int numthings = 0;

// _~[Anext tB[h 0 ŏĂ鎖O
sector_t    firstsector;    
linedef_t   firstlinedef;
vertex_t    firstvertex;
thing_t     firstthing;

object_t    selected;
object_t    picked;

char    defmidtexture[9] = "GRAY1";
char    defupptexture[9] = "GRAY1";
char    deflowtexture[9] = "GRAY1";

sector_t defsecstate =
{
    0, 128,
    { 'F', 'L', 'O', 'O', 'R', '1', '_', '1' }, { 'F', 'L', 'A', 'T', '1', '8' },
    160, 0, 0
};

BOOL mapalterd = FALSE;

void NotifyMapAlteration(void)
{
    if (!mapalterd)
    {
        mapalterd = TRUE;
        UpdateTitleBar();
    }
}

void ClearMap(void) // }bv͕ςȂ
{
    vertex_t    *v, *nextv;
    sector_t    *sec, *nextsec;
    linedef_t   *line, *nextline;
    thing_t     *thing, *nextthing;

    for (v = firstvertex.next ; v ; v = nextv)
    {
        nextv = v->next;
        free(v);
    }
    firstvertex.next = NULL;
    numvertices = 0;

    for (sec = firstsector.next ; sec ; sec = nextsec)
    {
        nextsec = sec->next;
        free(sec);
    }
    firstsector.next = NULL;
    numsectors = 0;

    for (line = firstlinedef.next ; line ; line = nextline)
    {
        nextline = line->next;
        free(line);
    }
    firstlinedef.next = NULL;
    numlinedefs = 0;

    for (thing = firstthing.next ; thing ; thing = nextthing)
    {
        nextthing = thing->next;
        free(thing);
    }
    firstthing.next = NULL;
    numthings = 0;

    selected.type = ot_none;
    picked.type = ot_none;

    numbsplines = 0;
    numsubsectors = 0;
    savecount = 0;
    //mapalterd = FALSE;
    //UpdateTitleBar();
}

void* LinePtrForNum(unsigned int num)
{
    unsigned int    i=0;
    linedef_t*      line;

    for (line = firstlinedef.next ; line ; line = line->next, i++)
    {
        if (i == num)
            return line;
    }

    return NULL;
}

void* VertexPtrForNum(unsigned int num)
{
    unsigned int    i=0;
    vertex_t*       v;

    for (v = firstvertex.next ; v ; v = v->next, i++)
    {
        if (i == num)
            return v;
    }

    return NULL;
}

void* ThingPtrForNum(unsigned int num)
{
    unsigned int    i=0;
    thing_t*        thing;

    for (thing = firstthing.next ; thing ; thing = thing->next, i++)
    {
        if (i == num)
            return thing;
    }

    return NULL;
}

int VertexNumForPtr(vertex_t* ptr)
{
    int         i=0;
    vertex_t*   v;

    for (v = firstvertex.next ; v ; v = v->next, i++)
    {
        if (v == ptr)
            return i;
    }

    Error("VertexNumForPtr: pointer not found");
    return -1;
}

int SectorNumForPtr(sector_t* ptr)
{
    int         i=0;
    sector_t*   sec;

    for (sec = firstsector.next ; sec ; sec = sec->next, i++)
    {
        if (sec == ptr)
            return i;
    }

    Error("SectorNumForPtr: pointer not found");
    return -1;
}

void* SectorPtrForNum(unsigned int num)
{
    unsigned int    i=0;
    sector_t*       sec;

    for (sec = firstsector.next ; sec ; sec = sec->next, i++)
    {
        if (i == num)
            return sec;
    }

    return NULL;
}

void ScreenToWorld(int x, int y, vertex_t* v)
{
    float   dx, dy;

    dx = viewwidth*x/screenwidth;
    dy = viewheight*y/screenheight;
    v->x = viewx - (viewwidth/2) + dx;
    v->y = viewy + (viewheight/2) - dy;
}

BOOL DoesIntersectWithLines(vertex_t v1, vertex_t v2)
{
    linedef_t*  line;

    for (line = firstlinedef.next ; line ; line = line->next)
    {
        if ((v1.snapped.type == ot_line && v1.snapped.ptr == line) ||
            (v2.snapped.type == ot_line && v2.snapped.ptr == line) ||
            (v1.snapped.type == ot_vertex && (v1.snapped.ptr == line->v1 || v1.snapped.ptr == line->v2)) ||
            (v2.snapped.type == ot_vertex && (v2.snapped.ptr == line->v1 || v2.snapped.ptr == line->v2)))
            continue;

        if (DoesIntersect(v1, v2, *(line->v1), *(line->v2)))
            return TRUE;
    }

    return FALSE;
}

vertex_t* AddVertex(vertex_t vertex)
{
    vertex_t *v, *newv;

    for (v = firstvertex.next ; v ; v = v->next)
    {
        if (v->x == vertex.x && v->y == vertex.y)
            return v;
    }

    newv = (vertex_t*)calloc(sizeof(vertex_t), 1);
    newv->x = vertex.x;
    newv->y = vertex.y;
    for (v = &firstvertex ; v->next ; v = v->next)
        ;
    v->next = newv;
    newv->next = NULL;
    numvertices++;

    return newv;
}

void InsertVertex(vertex_t v, linedef_t* line)
{
    vertex_t*   vp;
    linedef_t   *newline, *line_p;

    vp = AddVertex(v);
    newline = (linedef_t*)calloc(sizeof(linedef_t), 1);
    memcpy(newline, line, sizeof(linedef_t));
    line->v2 = vp;
    newline->v1 = vp;

    for (line_p = &firstlinedef ; line_p->next ; line_p = line_p->next)
        ;
    line_p->next = newline;
    newline->next = NULL;
    numlinedefs++;

    NotifyMapAlteration();
}

linedef_t* PointOnLine(vertex_t v)
{
    linedef_t*  line;

    for (line = firstlinedef.next ; line ; line = line->next)
    {
        if (IsOnLine(v, *line))
            return line;
    }

    return NULL;
}

void ResnapVertex(vertex_t* v1, vertex_t* v2)
{
    vertex_t*   v;
    linedef_t*  line;

    if (v1->snapped.type == ot_line)
    {
        for (v = firstvertex.next ; v ; v = v->next)
        {
            if (v1->x == v->x && v1->y == v->y)
            {
                v1->snapped.type = ot_vertex;
                v1->snapped.ptr = v;
                break;
            }
        }
    }

    if (v2->snapped.type == ot_line)
    {
        // I_(line strip ̎n_) LINEDEF ɂ鎞N
        for (v = firstvertex.next ; v ; v = v->next)
        {
            if (v2->x == v->x && v2->y == v->y)
            {
                v2->snapped.type = ot_vertex;
                v2->snapped.ptr = v;
                return;
            }
        }

        line = PointOnLine(*v2);
        if (line && line != v2->snapped.ptr)
            v2->snapped.ptr = line;
    }
}

void AddLinedef(vertex_t v1, vertex_t v2, sector_t* rightsec, sector_t* leftsec)
{
    linedef_t   *line, *line2, *line_p;
    BOOL        nonewline = FALSE;

    ResnapVertex(&v1, &v2); // InsertVertex()LinedefꂽɃXibv

    line = (linedef_t*)calloc(sizeof(linedef_t), 1);
    line->v1 = AddVertex(v1);
    line->v2 = AddVertex(v2);
    line->sides[0].sec = rightsec;

    switch (v1.snapped.type)
    {
    case ot_none:
        switch (v2.snapped.type)
        {
        case ot_none:
        case ot_vertex:
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;

        case ot_line:
            InsertVertex(v2, (linedef_t*)(v2.snapped.ptr));
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;
        }
        break;

    case ot_vertex:
        switch (v2.snapped.type)
        {
        case ot_none:
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;

        case ot_vertex:
            for (line_p = firstlinedef.next ; line_p ; line_p = line_p->next)
            {
                if ((line_p->v1 == v1.snapped.ptr && line_p->v2 == v2.snapped.ptr) ||
                    (line_p->v1 == v2.snapped.ptr && line_p->v2 == v1.snapped.ptr))
                {
                    free(line);
                    line = line_p;
                    if (line->v1 == v1.snapped.ptr && line->v2 == v2.snapped.ptr)
                        line->sides[0].sec = rightsec;
                    else
                        line->sides[1].sec = rightsec;
                    nonewline = TRUE;
                    break;
                }
            }
            if (!nonewline)
                if (leftsec)
                    line->sides[1].sec = leftsec;
            break;

        case ot_line:
            line_p = (linedef_t *)(v2.snapped.ptr);
            if (line_p->v1 == v1.snapped.ptr || line_p->v2 == v1.snapped.ptr)
            {
                if (line_p->v1 == v1.snapped.ptr)
                {
                    line_p->v1 = line->v2;
                    if (line_p->sides[1].sec)
                        line->sides[1].sec = line_p->sides[1].sec;
                }
                else
                {
                    line_p->v2 = line->v2;
                    line->sides[1].sec = line_p->sides[0].sec;
                }
                break;
            }
            InsertVertex(v2, line_p);
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;
        }
        break;

    case ot_line: // line strip ̎n_ LINEDEF ɂ鎞N
        switch (v2.snapped.type)
        {
        case ot_none:
            InsertVertex(v1, (linedef_t*)(v1.snapped.ptr));
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;

        case ot_vertex:
            line_p = (linedef_t *)(v1.snapped.ptr);
            if (line_p->v1 == v2.snapped.ptr || line_p->v2 == v2.snapped.ptr)
            {
                if (line_p->v2 == v2.snapped.ptr)
                {
                    line_p->v2 = line->v1;
                    if (line_p->sides[1].sec)
                        line->sides[1].sec = line_p->sides[1].sec;
                }
                else
                {
                    line_p->v1 = line->v1;
                    line->sides[1].sec = line_p->sides[0].sec;
                }
                break;
            }
            InsertVertex(v1, line_p);
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;

        case ot_line:   
            if (v1.snapped.ptr == v2.snapped.ptr) 
            {
                line2 = (linedef_t*)calloc(sizeof(linedef_t), 1);
                memcpy(line2, v1.snapped.ptr, sizeof(linedef_t));
                if (line2->sides[0].sec == leftsec)
                {
                    // 
                    ((linedef_t *)(v1.snapped.ptr))->v2 = line->v1;
                    line2->v1 = line->v2;
                    if (line2->sides[1].sec)
                        line->sides[1].sec = line2->sides[1].sec;
                }
                else
                {
                    // t
                    ((linedef_t *)(v1.snapped.ptr))->v2 = line->v2;
                    line2->v1 = line->v1;
                    line->sides[1].sec = line2->sides[0].sec;
                }
                for (line_p = &firstlinedef ; line_p->next ; line_p = line_p->next)
                    ;
                line_p->next = line2;
                line2->next = NULL;
                numlinedefs++;
                break;
            }
            InsertVertex(v1, (linedef_t*)(v1.snapped.ptr));
            InsertVertex(v2, (linedef_t*)(v2.snapped.ptr));
            if (leftsec)
                line->sides[1].sec = leftsec;
            break;
        }
        break;
    }

    if (line->sides[1].sec)
    {
        if (line->sides[0].sec->floorheight > line->sides[1].sec->floorheight)
        {
            memcpy(line->sides[1].lower, deflowtexture, 8);
            strcpy(line->sides[0].lower, "-");
        }
        else if (line->sides[0].sec->floorheight < line->sides[1].sec->floorheight)
        {
            memcpy(line->sides[0].lower, deflowtexture, 8);
            strcpy(line->sides[1].lower, "-");
        }
        else
        {
            strcpy(line->sides[0].lower, "-");
            strcpy(line->sides[1].lower, "-");
        }

        if (line->sides[0].sec->ceilingheight > line->sides[1].sec->ceilingheight)
        {
            memcpy(line->sides[0].upper, defupptexture, 8);
            strcpy(line->sides[1].upper, "-");
        }
        else if (line->sides[0].sec->ceilingheight < line->sides[1].sec->ceilingheight)
        {
            memcpy(line->sides[1].upper, defupptexture, 8);
            strcpy(line->sides[0].upper, "-");
        }
        else
        {
            strcpy(line->sides[0].upper, "-");
            strcpy(line->sides[1].upper, "-");
        }

        strcpy(line->sides[0].middle, "-");
        strcpy(line->sides[1].middle, "-");
    }
    else
    {
        memcpy(line->sides[0].middle, defmidtexture, 8);
        strcpy(line->sides[0].upper, "-");
        strcpy(line->sides[0].lower, "-");
    }

    if (!nonewline)
    {
        for (line_p = &firstlinedef ; line_p->next ; line_p = line_p->next)
            ;
        line_p->next = line;
        line->next = NULL;
        numlinedefs++;
    }
}

sector_t* PointInSector(vertex_t v)
{
    sector_t*   sec;

    for (sec = firstsector.next ; sec ; sec = sec->next)
    {
        if (IsInSector(v, sec))
            return sec;
    }

    return NULL;
}

sector_t* FindOuterSector(vertex_t* verts, int numverts)
{
    int         i;
    float       dx, dy;
    vertex_t    v;

    for (i=0 ; i<numverts ; i++)
    {
        if (verts[i].snapped.type == ot_none)
            return PointInSector(verts[i]);
    }

    for (i=0 ; i<numverts ; i++)
    {
        dx = verts[(i+1)%numverts].x - verts[i].x;
        dy = verts[(i+1)%numverts].y - verts[i].y;
        v.x = verts[i].x + 0.5f*dx;
        v.y = verts[i].y + 0.5f*dy;
        if (!PointOnLine(v))
            return PointInSector(v);
    }

    return NULL;
}

BOOL AddSector(vertex_t* verts, int numverts)
{
    sector_t    *sec, *sec_p, *outersec;
    int         i;
    
    if (IsCCW(verts, numverts))
    {
        sec = NULL;

        // ɁAvoid space  linedef  linedef ƏdȂĂȂ
        // eXgR[h
    }
    else
        sec = (sector_t*)calloc(sizeof(sector_t), 1);

    outersec = FindOuterSector(verts, numverts);

    if (!sec && !outersec)
    {
        Alert("void space ̒ void space 邱Ƃ͏o܂");
        return FALSE;
    }

    if (sec)
        memcpy(sec, &defsecstate, sizeof(sector_t));

    for (i=0 ; i<numverts ; i++)
    {
        if (sec)
            AddLinedef(verts[i], verts[(i+1)%numverts], sec, outersec);
        else
            AddLinedef(verts[i], verts[(i+1)%numverts], outersec, NULL);
    }

    NotifyMapAlteration();

    if (!sec)
        return TRUE;

    for (sec_p = &firstsector ; sec_p->next ; sec_p = sec_p->next)
        ;
    sec_p->next = sec;
    sec->next = NULL;
    numsectors++;

    return TRUE;
}

void AddThing(int id, int x, int y)
{
    thing_t*    thing;
    thing_t*    thing_p;
    vertex_t    v;

    thing = (thing_t*)calloc(sizeof(thing_t), 1);
    ScreenToWorld(x, y, &v);
    thing->x = v.x;
    thing->y = v.y;
    thing->angle = 90;
    thing->type = thingdefs[id].type;
    thing->options = 1 + 2 + 4;
    thing->id = id;

    for (thing_p = &firstthing ; thing_p->next ; thing_p = thing_p->next)
        ;
    thing_p->next = thing;
    thing->next = NULL;
    numthings++;

    NotifyMapAlteration();
}

BOOL CheckVertex(vertex_t* v)
{
    vertex_t    v1, v2;
    linedef_t*  line;

    if (gridsize)
    {
        v->x = (float)floor((v->x + (double)gridsize/2) / gridsize) * gridsize;
        v->y = (float)floor((v->y + (double)gridsize/2) / gridsize) * gridsize;
    }

    for (line = firstlinedef.next ; line ; line = line->next)
    {
        if (line->v1 == v || line->v2 == v)
        {
            v1 = *v;
            v1.snapped.type = ot_vertex;
            v1.snapped.ptr = v;
            if (line->v1 == v)
            {
                v2 = *(line->v2);
                v2.snapped.type = ot_vertex;
                v2.snapped.ptr = line->v2;
            }
            else
            {
                v2 = *(line->v1);
                v2.snapped.type = ot_vertex;
                v2.snapped.ptr = line->v1;
            }
            if (DoesIntersectWithLines(v1, v2))
            {
                Alert("LINEDEF m悤 VERTEX ̈ړ͏o܂");
                return FALSE;
            }
        }
    }

    return TRUE;
}

float xoff, yoff;

void CalculateOffset(float centerx, float centery, int x, int y)
{
    vertex_t v;

    ScreenToWorld(x, y, &v);
    xoff = v.x - centerx;
    yoff = v.y - centery;
}

void MoveVertex(vertex_t* vert, int x, int y)
{
    vertex_t v;

    ScreenToWorld(x, y, &v);
    vert->x = v.x - xoff;
    vert->y = v.y - yoff;
}

void MoveThing(thing_t* thing, int x, int y)
{
    vertex_t v;

    ScreenToWorld(x, y, &v);
    thing->x = v.x - xoff;
    thing->y = v.y - yoff;
}

void DeleteVertex(vertex_t* v)
{
    int         i=0;
    linedef_t*  line;
    linedef_t*  lines[2];
    vertex_t    v1, v2;
    int         remain;
    vertex_t*   vert;

    for (line = firstlinedef.next ; line ; line = line->next)
    {
        if (line->v1 == v || line->v2 == v)
        {
            if (i < 2)
            {
                lines[i++] = line;
            }
            else
            {
                Alert("Oȏ LINEDEF ƌqĂ VERTEX 폜邱Ƃ͏o܂");
                return;
            }
        }
    }
    if (i == 1)
    {
        Alert(" LINEDEF ƂqĂȂ VERTEX ł");
        return;
    }
    if (i == 0)
    {
        Alert("Ǘ VERTEX 폜܂");
        goto deletevert;
    }

    for (i=0 ; i<2 ; i++)
    {
        if (lines[i]->v2 == v) // ȂLinedef͌ɂȂȂ
        {
            v1 = *(lines[i]->v1);
            v1.snapped.type = ot_vertex;
            v1.snapped.ptr = lines[i]->v1;
            v2 = *(lines[!i]->v2);
            v2.snapped.type = ot_vertex;
            v2.snapped.ptr = lines[!i]->v2;
            remain = i;
        }
    }
    if (DoesIntersectWithLines(v1, v2))
    {
        Alert("LINEDEF m悤 VERTEX ̍폜͏o܂");
        return;
    }

    lines[remain]->v2 = (vertex_t*)(v2.snapped.ptr);
    for (line = &firstlinedef ; line->next != lines[!remain] ; line = line->next)
        ;
    line->next = lines[!remain]->next;
    free(lines[!remain]);
    numlinedefs--;

deletevert:
    for (vert = &firstvertex ; vert->next != v ; vert = vert->next)
        ;
    vert->next = v->next;
    free(v);
    numvertices--;

    NotifyMapAlteration();
}

void DeleteThing(thing_t* thing)
{
    thing_t* thing_p;

    for (thing_p = &firstthing ; thing_p->next ; thing_p = thing_p->next)
    {
        if (thing_p->next == thing)
            break;
    }
    thing_p->next = thing->next;
    free(thing);
    numthings--;

    NotifyMapAlteration();
}

void DeleteSector(sector_t* sec)
{
    linedef_t   *line, *prev;
    vertex_t    *v, *pv;
    int         count=0;
    sector_t*   sec_p;

    for (line = firstlinedef.next, prev = &firstlinedef ; line ; )
    {
        if (line->sides[0].sec == sec)
        {
            if (line->sides[1].sec)
            {
                v = line->v1;
                line->v1 = line->v2;
                line->v2 = v;
                line->sides[0].sec = line->sides[1].sec;
                line->sides[0].xoffset = 0;
                line->sides[0].yoffset = 0;
                memcpy(line->sides[0].middle, defmidtexture, 8);
                strcpy(line->sides[0].lower, "-");
                strcpy(line->sides[0].upper, "-");
                line->sides[1].sec = NULL;
            }
            else
            {
                prev->next = line->next;
                free(line);
                numlinedefs--;
                line = prev->next;
                continue;
            }
        }
        else if (line->sides[1].sec == sec)
        {
            line->sides[0].xoffset = 0;
            line->sides[0].yoffset = 0;
            memcpy(line->sides[0].middle, defmidtexture, 8);
            strcpy(line->sides[0].lower, "-");
            strcpy(line->sides[0].upper, "-");
            line->sides[1].sec = NULL;
        }

        line = line->next;
        prev = prev->next;
    }

    // Ǘ vertex 폜
    for (v = firstvertex.next, pv = &firstvertex ; v ; )
    {
        for (line = firstlinedef.next ; line ; line = line->next)
        {
            if (line->v1 == v || line->v2 == v)
                count++;
        }
        if (!count)
        {
            pv->next = v->next;
            free(v);
            numvertices--;
            v = pv->next;
            continue;
        }
        if (count == 1)
            Debug("DeleteSector:  linedef ƂqĂȂ vertex ܂\n");

        v = v->next;
        pv = pv->next;
        count = 0;
    }

    for (sec_p = &firstsector ; sec_p->next != sec ; sec_p = sec_p->next)
        ;
    sec_p->next = sec->next;
    free(sec);
    numsectors--;

    NotifyMapAlteration();
}

/*----------------
    Line Strip
----------------*/

BOOL        secdrawmode = FALSE;
#define     MAXNUMLSVERTS   256
vertex_t    lsverts[MAXNUMLSVERTS+1];
int         numlsverts = 0;

BOOL LS_DoesIntersectWithLines(vertex_t v1, vertex_t v2)
{
    int i;

    if (v2.x == lsverts[0].x && v2.y == lsverts[0].y)
        i = 1;
    else
        i = 0;

    for ( ; i<(numlsverts-2) ; i++)
    {
        if (DoesIntersect(v1, v2, lsverts[i], lsverts[i+1]))
            return TRUE;
    }

    return DoesIntersectWithLines(v1, v2);
}

void LS_SnapVertex(vertex_t* v)
{
    switch (picked.type)
    {
    case ot_vertex:
        if (picked.ptr)
        {
            v->snapped.type = ot_vertex;
            v->snapped.ptr = picked.ptr;
            v->x = ((vertex_t *)(picked.ptr))->x;
            v->y = ((vertex_t *)(picked.ptr))->y;
        }
        else
        {
            v->x = lsverts[0].x;
            v->y = lsverts[0].y;
        }
        return;

    case ot_line:
        v->snapped.type = ot_line;
        v->snapped.ptr = picked.ptr;
        SnapToLine(v, (linedef_t *)(picked.ptr));
        return;
    }

    v->snapped.type = ot_none;

    if (!gridsize)
        return;

    v->x = (float)floor((v->x + (double)gridsize/2) / gridsize) * gridsize;
    v->y = (float)floor((v->y + (double)gridsize/2) / gridsize) * gridsize;
}

void LS_Close(void)
{
    if (numlsverts < 3)
        return;

    if (LS_DoesIntersectWithLines(lsverts[numlsverts-1], lsverts[0]))
    {
        Alert("LINEDEF  LINEDEF ƌ邱Ƃ͏o܂");
        return;
    }

    if (!AddSector(lsverts, numlsverts))
        return;

    secdrawmode = FALSE;
    numlsverts = 0;
}

void LS_AddVertex(int x, int y)
{
    vertex_t v;

    memset(&v, 0, sizeof(vertex_t));

    ScreenToWorld(x, y, &v);
    LS_SnapVertex(&v);

    if (!numlsverts)
    {
        lsverts[0] = v;
        lsverts[1] = v;
        numlsverts = 1;
        return;
    }

    if (v.x == lsverts[0].x && v.y == lsverts[0].y)
    {
        LS_Close();
        return;
    }

    if (numlsverts >= MAXNUMLSVERTS)
    {
        Alert("x VERTEX  %d 葽 SECTOR 邱Ƃ͏o܂", MAXNUMLSVERTS);
        return;
    }

    if (LS_DoesIntersectWithLines(lsverts[numlsverts-1], v))
    {
        Alert("LINEDEF  LINEDEF ƌ邱Ƃ͏o܂");
        return;
    }

    lsverts[numlsverts++] = v;
    lsverts[numlsverts] = v;
}

void LS_MoveVertex(int x, int y)
{
    vertex_t v;

    ScreenToWorld(x, y, &v);
    lsverts[numlsverts] = v;
}

void LS_Abort(void)
{
    secdrawmode = FALSE;
    numlsverts = 0;
}

void LS_DecrementVertex(void)
{
    if (numlsverts == 1)
    {
        LS_Abort();
        return;
    }

    lsverts[numlsverts-1] = lsverts[numlsverts];
    numlsverts--;
}