#include <windows.h>
#include "map.h"
#include "buildbsp.h"

short   datalist[0x10000], *data_p;
short/*float*/  orgx, orgy;

#define	BLOCKSIZE   128

void GenerateBlockList (int x, int y)
{
    float       xl, xh, yl, yh;
    linedef_t*  line;
    int         i=0;
    point_t     pt1, pt2;
    divline_t   ld;
    int         s1,s2;

    *data_p++ = 0;  // leave space for thing links

    xl = (float)orgx + x*BLOCKSIZE;
    xh = xl+BLOCKSIZE;
    yl = (float)orgy + y*BLOCKSIZE;
    yh = yl+BLOCKSIZE;

    for (line = firstlinedef.next ; line ; line = line->next, i++)
    {
        pt1.x = line->v1->x;
        pt1.y = line->v1->y;
        pt2.x = line->v2->x;
        pt2.y = line->v2->y;

        if ((pt1.x < xl && pt2.x < xl) ||
            (pt1.x > xh && pt2.x > xh) ||
            (pt1.y < yl && pt2.y < yl) ||
            (pt1.y > yh && pt2.y > yh))
            continue;

        ld.dx = pt2.x - pt1.x;
        ld.dy = pt2.y - pt1.y;

        if (!ld.dx || !ld.dy)
        {
            *data_p++ = i;
            continue;
        }

        ld.pt = pt1;

        if (ld.dx*ld.dy > 0)
        {   // positive slope
            pt1.x = xl;
            pt1.y = yh;
            pt2.x = xh;
            pt2.y = yl;
        }
        else
        {   // negetive slope
            pt1.x = xh;
            pt1.y = yh;
            pt2.x = xl;
            pt2.y = yl;
        }

        s1 = PointOnSide (&pt1, &ld);
	    s2 = PointOnSide (&pt2, &ld);

        if (s1 != s2)
            *data_p++ = i;
    }

    *data_p++ = -1; // end of list marker
}

/*
================
=
= SaveBlocks
=
block lump holds:
orgx
orgy
blockwidth
blockheight
listoffset[blockwidth*blockheight]
lists
	one short left blank for thing list
	linedef numbers
	-1 terminator
	
================
*/

extern short worldbounds[];
enum {BOXTOP,BOXBOTTOM,BOXLEFT,BOXRIGHT};
void addName(char* name, void* data, int size);

void SaveBlocks(void)
{
    int     blockwidth, blockheight;
    int     x,y, len;
    short   *pointer_p;

    blockwidth = ((worldbounds[BOXRIGHT]-worldbounds[BOXLEFT]+16)+BLOCKSIZE-1)/BLOCKSIZE;
    blockheight = ((worldbounds[BOXTOP]-worldbounds[BOXBOTTOM]+16)+BLOCKSIZE-1)/BLOCKSIZE;
    orgx = worldbounds[BOXLEFT]-8;
    orgy = worldbounds[BOXBOTTOM]-8;

    pointer_p = datalist;
    *pointer_p++ = orgx;
    *pointer_p++ = orgy;
    *pointer_p++ = blockwidth;
    *pointer_p++ = blockheight;

    data_p = pointer_p + blockwidth*blockheight;

    for (y=0 ; y<blockheight ; y++)
    {
        for (x=0 ; x<blockwidth ; x++)
        {
            len = data_p - datalist;
            *pointer_p++ = len;
            GenerateBlockList (x,y);
        }
    }
	
    len = 2*(data_p-datalist);

    addName("blockmap", datalist, len);
}
