// ǉ郉Cu: comctl32.lib opengl32.lib glu32.lib htmlhelp.lib

#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include <commctrl.h>
#include <io.h>
#include <stdio.h>
#include <direct.h>
#include <process.h>
#include <htmlhelp.h>
#include "sysmain.h"
#include "resource.h"
#include "sysutils.h"
#include "opengl.h"
#include "thingdef.h"
#include "map.h"
#include "wcm.h"
#include "dialog.h"
#include "geometry.h"
#include "buildbsp.h"
#include "specname.h"
#include "doomdata.h"

char    szAppName[] = "WadCraft";
HINSTANCE hInst;
HWND    hMainWnd;
HWND    hToolBar;
HWND    hToolTip;
HMENU   hGridMenu;
HWND    hStatusBar;
HWND    hChildWnd;
HWND    hProgDialog;
HIMAGELIST himl;
TBBUTTON tbButtons[] =
{
    { 0, IDM_NEW,    TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE}, // TB_SETPADDINGLɂɂBTNS_AUTOSIZEw肵ĂKv
    { 1, IDM_OPEN,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 2, IDM_SAVE,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 0, 0,          TBSTATE_ENABLED, BTNS_SEP                   },
    { 3, IDM_EDIT,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 4, IDM_DELETE, TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
	{ 0, 0,          TBSTATE_ENABLED, BTNS_SEP                   },
    { 5, IDM_GRID,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 6, IDM_AXIS,   TBSTATE_ENABLED, BTNS_CHECK  | BTNS_AUTOSIZE},
    { 0, 0,          TBSTATE_ENABLED, BTNS_SEP                   },
    { 7, IDM_BUILD,  TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 8, IDM_PLAY,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 0, 0,          TBSTATE_ENABLED, BTNS_SEP                   },
    { 9, IDM_DEFTEX, TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    {10, IDM_DEFSEC, TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE},
    { 0, 0,          TBSTATE_ENABLED, BTNS_SEP                   },
    {11, IDM_HELP,   TBSTATE_ENABLED, BTNS_BUTTON | BTNS_AUTOSIZE}
};
int     cxscreen, cyscreen;
int     screenwidth, screenheight;
BOOL    insvertmode = FALSE;
BOOL    movemode = FALSE;
vertex_t startv;
BOOL    savemessage = FALSE;
BOOL    buildmessage = FALSE;
OPENFILENAME ofn;
char    szFilter[] = "WadCraft}bvt@C {*.wcm}\0 *.wcm\0\0";
char    szFile[1024];
char    szFileTitle[256];
char    szDefExt[] = "wcm";
HMENU   hThingMenu;
PBITMAPINFO pbmi;
PBITMAPINFO pbmi2;
PBITMAPINFO pbmi3;
PBITMAPINFO pbmi4;
PBITMAPINFO pbmi5;
char    configfile[] = "wadcraft.cfg";
int     numdefaults;
char    gamefilename[1024];
int     nomonsters;
int     nomusic;
char    fileoptparms[256];
char    cmdlineparms[256];
int     calcpvs;
int     debugout;

LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ChildWndProc(HWND, UINT, WPARAM, LPARAM);
void InitThingMenu(void);
void UpdateTitleBar(void);
void UpdateStatusBar(void);
void LoadConfig(void);
void SaveConfig(void);
void PlayMap(void);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
    MSG         msg;
	WNDCLASSEX  wndclass;

    LoadConfig();

    if (!_access(debugfile, 0))
        remove(debugfile);

    if (!LoadWadFile("doom2.wad"))
        Error("doom2.wad t@C̓ǂݍ݂Ɏs܂");

    InitThingMenu();    // pbmi  ofn ̏s

    cxscreen = GetSystemMetrics(SM_CXSCREEN);
    cyscreen = GetSystemMetrics(SM_CYSCREEN);

    hInst = hInstance;

    wndclass.cbSize = sizeof(WNDCLASSEX);
    wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = MainWndProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, 0, 0, 0);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wndclass.lpszMenuName = "menubar";
	wndclass.lpszClassName = szAppName;
    wndclass.hIconSm = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_SMALL), IMAGE_ICON, 0, 0, 0);

	RegisterClassEx(&wndclass);

	hMainWnd = CreateWindow(szAppName,
	                        szAppName,
	                        WS_OVERLAPPEDWINDOW,
	                        2,
	                        2,
	                        GetSystemMetrics(SM_CXMAXIMIZED)-12,
	                        GetSystemMetrics(SM_CYMAXIMIZED)-12,
	                        NULL,
	                        NULL,
	                        hInstance,
	                        NULL);

	ShowWindow(hMainWnd, iCmdShow);
	UpdateWindow(hMainWnd);
    UpdateTitleBar();

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    SaveConfig();

    return msg.wParam;
}

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int tbheight, sbheight;
    RECT rect;
    int w, h;
    int parts[4];
    int id;
    UINT flag;
    int delta;
    float factor;
    //INITCOMMONCONTROLSEX iccex;
    static BOOL bNew = FALSE;

    switch (message)
    {
    case WM_CREATE:
        InitCommonControls();/*
        iccex.dwICC = ICC_WIN95_CLASSES;
        iccex.dwSize = sizeof(INITCOMMONCONTROLSEX);
        InitCommonControlsEx(&iccex);*/
        // c[o[̍쐬
        hToolBar = CreateWindowEx(0, TOOLBARCLASSNAME, NULL, WS_CHILD | WS_VISIBLE | TBSTYLE_FLAT, // TBSTYLE_FLATw肵ȂƏc̃Zp[^ɂȂȂ
                                  0, 0, 0, 0, hwnd, (HMENU)IDC_TOOLBAR, hInst, NULL);
        SendMessage(hToolBar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
        himl = ImageList_Create(24, 24, ILC_COLOR32, 12, 0);
        ImageList_Add(himl,
                      (HBITMAP)LoadImage(hInst, MAKEINTRESOURCE(IDB_IMAGESTRIP), IMAGE_BITMAP,0, 0, LR_CREATEDIBSECTION),
                      NULL);
        SendMessage(hToolBar, TB_SETIMAGELIST, 0, (LPARAM)himl);
        SendMessage(hToolBar, TB_ADDBUTTONS, 17, (LPARAM)tbButtons);
        SendMessage(hToolBar, TB_SETINDENT, 10, 0);
        //SendMessage(hToolBar, TB_SETPADDING, 0, (LPARAM)MAKELPARAM(8, 0));
        //SendMessage(hToolBar, WM_USER+96/*TB_SETLISTGAP*/, 8, 0);
        SendMessage(hToolBar, TB_SETTOOLTIPS, (WPARAM)hToolTip, 0);
        SendMessage(hToolBar, TB_AUTOSIZE, 0, 0); // GetClientRect()ĂяoOɃTCYĂ
        GetClientRect(hToolBar, &rect);
        tbheight = rect.bottom;
        // c[`bv̍쐬
        TOOLINFO ti;
        int i;
        hToolTip = CreateWindowEx(0,TOOLTIPS_CLASS, NULL, TTS_ALWAYSTIP,
                                  CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hwnd, NULL, hInst, NULL);
        ti.cbSize = sizeof(TOOLINFO);
        ti.hwnd   = hToolBar;
        ti.hinst  = hInst;
        ti.uFlags = TTF_SUBCLASS;
        for(i=0 ; i<17 ; i++)
        {
            if (i==3 || i==6 || i==9 || i==12 || i==15) // Zp[^XLbv
                continue;
            SendMessage(hToolBar, TB_GETITEMRECT, i, (LPARAM)&ti.rect);
            ti.uId      = tbButtons[i].idCommand;
            ti.lpszText = (LPTSTR)tbButtons[i].idCommand;
            SendMessage(hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);
        }
        SendMessage(hToolBar, TB_SETTOOLTIPS, (WPARAM)hToolTip, 0);
        // Obhc[{^̃hbv_Ej[̍쐬
        hGridMenu = GetSubMenu(GetSubMenu(GetMenu(hwnd), 2), 0);
        // Xe[^Xo[̍쐬
        hStatusBar = CreateWindowEx(0, STATUSCLASSNAME, NULL, WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
                                    0, 0, 0, 0, hwnd, (HMENU)IDC_STATUSBAR, hInst, NULL);
        GetClientRect(hStatusBar, &rect);
        sbheight = rect.bottom;
        SendMessage(hStatusBar, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), 0);
        // qEBhE̍쐬
        WNDCLASS wndclass;
        GetClientRect(hwnd, &rect);
        wndclass.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
        wndclass.lpfnWndProc = ChildWndProc;
        wndclass.cbClsExtra = 0;
        wndclass.cbWndExtra = 0;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = LoadCursor(NULL,IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
        wndclass.lpszMenuName = NULL;
        wndclass.lpszClassName = "ChildWndClass";
        RegisterClass(&wndclass);
        hChildWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "ChildWndClass", NULL, WS_CHILD | WS_VISIBLE,
                                   0, tbheight, rect.right, rect.bottom-(tbheight+sbheight), hwnd, NULL, hInst, NULL);
        CheckMenuRadioItem(GetMenu(hwnd), IDM_GRIDNONE, IDM_GRID64, IDM_GRIDNONE, MF_BYCOMMAND);
        return 0;

    case WM_SIZE:
        w = LOWORD(lParam);
        h = HIWORD(lParam);
        parts[2] = w - 330;
        parts[1] = parts[2] - 90;
        parts[0] = parts[1] - 140;
        parts[3] = -1;
        SendMessage(hStatusBar, SB_SETPARTS, 4, (LPARAM)parts);
        MoveWindow(hStatusBar, 0, h - sbheight, w, sbheight, TRUE);
        UpdateStatusBar();
        SendMessage(hToolBar, TB_AUTOSIZE, 0, 0);
        MoveWindow(hChildWnd, 0, tbheight, w, h-(tbheight+sbheight), TRUE);
        return 0;

    case WM_KEYDOWN:
        switch(wParam)
        {
        case VK_CONTROL:
            selected.type = ot_none; // ɑI
            if (!secdrawmode && !numlsverts && !pvstestmode)
            {
                POINT   pt;
                secdrawmode = TRUE; // n_łOłACtrlL[Ă΁AꎞI secdrawmode ɂāAJ[\̉̃IuWFNgI\ɂB
                GetCursorPos(&pt);
                ScreenToClient(hChildWnd, &pt);
                PickObjectsUnderCursor(pt.x, pt.y);
             }
            break;

        case VK_RETURN:
            if (secdrawmode)
                LS_Close();
            else
            {
                SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_EDIT, 0), 0);
                return 0;
            }
            break;

        case VK_ESCAPE:
            if (secdrawmode)
                LS_Abort();
            else
                selected.type = ot_none;
            break;

        case VK_DELETE:
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_DELETE, 0), 0);
            return 0;

        case VK_F1:
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_HELP, 0), 0);
            return 0;

        case VK_UP:
            delta = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? 20 : 10;
            TranslateView(0, delta);
            break;

        case VK_DOWN:
            delta = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? -20 : -10;
            TranslateView(0, delta);
            break;

        case VK_LEFT:
            delta = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? -20 : -10;
            TranslateView(delta, 0);
            break;

        case VK_RIGHT:
            delta = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? 20 : 10;
            TranslateView(delta, 0);
            break;

        case 'A':
            FitMapToView();
            break;

        case 'C':
            CenterView();
            break;

        case 'F':
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_FLIP, 0), 0);
            return 0;

        case 'I':
            factor = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? (1.01f*1.01f) : (1.01f);
            ScaleView(factor);
            break;

        case 'O':
            factor = HIBYTE(GetAsyncKeyState(VK_SHIFT)) ? (0.99f*0.99f) : (0.99f);
            ScaleView(factor);
            break;

        case 'R':
            ResetScale();
            break;
        }
        InvalidateRect(hChildWnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_KEYUP:
        switch(wParam)
        {
        case VK_CONTROL:
            if (secdrawmode && !numlsverts)
                secdrawmode = FALSE; // ꎞI secdrawmode B
            break;
        }
        InvalidateRect(hChildWnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_SYSKEYDOWN:
        switch (wParam)
        {
        case VK_MENU:
            selected.type = ot_none;
            if (!insvertmode && !pvstestmode)
            {
                POINT   pt;
                insvertmode = TRUE;
                GetCursorPos(&pt);
                ScreenToClient(hChildWnd, &pt);
                PickObjectsUnderCursor(pt.x, pt.y);
            }
            break;
        }
        InvalidateRect(hChildWnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_SYSKEYUP:
        switch (wParam)
        {
        case VK_MENU:
            if (insvertmode)
                insvertmode = FALSE;
            break;
        }
        InvalidateRect(hChildWnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_COMMAND:
        id = LOWORD(wParam);
        switch(id)
        {
        case IDM_NEW:
            bNew = TRUE;
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_SAVEAS, 0), 0);
            if (szFile[0] != 0)
            {
                //ClearMap();
                SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_GAMEMAP, 0), 0);
            }
            break;

        case IDM_OPEN:
            szFile[0] = 0;
            if (GetOpenFileName(&ofn))
                LoadMapFile(szFile);
            break;

        case IDM_SAVEAS:
            szFile[0] = 0;
            if (GetSaveFileName(&ofn))
            {
                if (bNew)
                    ClearMap();
                ChangeMapName(szFile);
                SaveMapFile();
                savemessage = TRUE;
            }
            if (bNew)
                bNew = FALSE;
            break;

        case IDM_SAVE:
            if (!strcmp(mapfilename, "untitled.wcm") && !savecount)
            {
                if (MessageBox(hwnd, "}bvt@C̖OƕۑꏊftHĝ܂܂łBύX܂H",
                               "㏑ۑ", MB_ICONEXCLAMATION | MB_YESNO) == IDYES)
                {
                    SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_SAVEAS, 0), 0);
                    return 0;
                }
            }
            SaveMapFile();
            savemessage = TRUE;
            break;

        case IDM_CLEAR:
            ClearMap();
            break;

        case IDM_EXIT:
            PostQuitMessage(0);
            return 0;

        case IDM_EDIT:
            switch (selected.type)
            {
            case ot_line:
                DialogBox(hInst, "lineedit", hwnd, (DLGPROC)LineEditDlgProc);
                break;
            case ot_sector:
                DialogBox(hInst, "secedit", hwnd, (DLGPROC)SecEditDlgProc);
                break;
            case ot_thing:
                DialogBox(hInst, "thingedit", hwnd, (DLGPROC)ThingEditDlgProc);
                InvalidateRect(hChildWnd, NULL, FALSE);
                break;
            }
            break;

        case IDM_DELETE:
            switch (selected.type)
            {
            case ot_vertex:
                DeleteVertex((vertex_t*)selected.ptr);
                break;
            case ot_line:
                break;
            case ot_sector:
                DeleteSector((sector_t*)selected.ptr);
                break;
            case ot_thing:
                DeleteThing((thing_t*)selected.ptr);
                break;
            }
            selected.type = ot_none;
            break;

        case IDM_FLIP:
            if (selected.type == ot_line && ((linedef_t*)selected.ptr)->sides[1].sec)
            {
                linedef_t*  line = (linedef_t*)selected.ptr;
                vertex_t*   v1;
                sidedef_t   s0;

                v1 = line->v1;
                line->v1 = line->v2;
                line->v2 = v1;
                s0 = line->sides[0];
                line->sides[0] = line->sides[1];
                line->sides[1] = s0;
            }
            break;

        case IDM_GRID:
            SendMessage(hToolBar, TB_GETRECT, IDM_GRID, (LPARAM)&rect);
            MapWindowPoints(hToolBar, HWND_DESKTOP, (LPPOINT)&rect, 2);
            TrackPopupMenu(hGridMenu, 0, rect.left, rect.bottom, 0, hwnd, NULL);
            break;

        case IDM_GRIDNONE:
        case IDM_GRID8:
        case IDM_GRID16:
        case IDM_GRID32:
        case IDM_GRID64:
            CheckMenuRadioItem(GetMenu(hwnd), IDM_GRIDNONE, IDM_GRID64, id, MF_BYCOMMAND);
            id = id - IDM_GRIDNONE;
            if (id)
                gridsize = 4<<id;
            else
                gridsize = 0;
            break;

        case IDM_AXIS:
            drawaxis = !drawaxis;
            flag = drawaxis ? MFS_CHECKED : MFS_UNCHECKED;
            CheckMenuItem(GetMenu(hwnd), id, MF_BYCOMMAND | flag);
            if (drawaxis)
                SendMessage(hToolBar, TB_SETSTATE, IDM_AXIS, TBSTATE_CHECKED | TBSTATE_ENABLED);
            else
                SendMessage(hToolBar, TB_SETSTATE, IDM_AXIS, TBSTATE_ENABLED);
            break;

        case IDM_BSPLINE:
            drawbspline = !drawbspline;
            flag = drawbspline ? MFS_CHECKED : MFS_UNCHECKED;
            CheckMenuItem(GetMenu(hwnd), id, MF_BYCOMMAND | flag);
            break;

        case IDM_PVSTEST:
            pvstestmode = !pvstestmode;
            flag = pvstestmode ? MFS_CHECKED : MFS_UNCHECKED;
            CheckMenuItem(GetMenu(hwnd), id, MF_BYCOMMAND | flag);
            if (pvstestmode)
            {
                selected.type = ot_none;
                pickedss = -1;
            }
            break;

        case IDM_BUILD:
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_SAVE, 0), 0);
            hProgDialog = CreateDialog(hInst, "buildprogress", hwnd, NULL);
            BuildBSP();
            DestroyWindow(hProgDialog);
            buildmessage = TRUE;
            break;

        case IDM_PLAY:
            SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_BUILD, 0), 0);
            PlayMap();
            break;

        case IDM_BUILDOPTION:
            DialogBox(hInst, "buildoption", hwnd, (DLGPROC)BuildOptionDlgProc);
            break;

        case IDM_PLAYOPTION:
            DialogBox(hInst, "playoption", hwnd, (DLGPROC)PlayOptionDlgProc);
            break;

        case IDM_DEFTEX:
            DialogBox(hInst, "deftex", hwnd, (DLGPROC)DefTexDlgProc);
            break;

        case IDM_DEFSEC:
            DialogBox(hInst, "defsec", hwnd, (DLGPROC)DefSecDlgProc);
            break;

        case IDM_GAMEMAP:
            DialogBox(hInst, "changemap", hwnd, (DLGPROC)ChangeMapDlgProc);
            break;

        case IDM_GAMELOC:
            DialogBox(hInst, "locategame", hwnd, (DLGPROC)LocateGameDlgProc);
            break;

        case IDM_HELP:
            HtmlHelp(hwnd, "wadcraft.chm", HH_DISPLAY_TOPIC, (DWORD_PTR)0);
            return 0;
        }
        InvalidateRect(hChildWnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
    }

    return DefWindowProc(hwnd, message, wParam, lParam);
}

LRESULT CALLBACK ChildWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int cursorx, cursory;
    static POINT pt;

    switch (message)
    {
    case WM_CREATE:
        SetupGL(hwnd);
        return 0;

    case WM_SIZE:
        screenwidth = LOWORD(lParam);
        screenheight = HIWORD(lParam);
        AdjustView(screenwidth, screenheight);
        return 0;

    case WM_PAINT:
        RenderScene();
        ValidateRect(hwnd, NULL);
        return 0;

    case WM_LBUTTONDOWN:
        cursorx = LOWORD(lParam);
        cursory = HIWORD(lParam);
        PickObjectsUnderCursor(cursorx, cursory);
        if (secdrawmode)
        {
            LS_AddVertex(cursorx, cursory);
        }
        else if (insvertmode && picked.type == ot_line)
        {
            vertex_t v;
            ScreenToWorld(cursorx, cursory, &v);
            SnapToLine(&v, (linedef_t *)(picked.ptr));
            InsertVertex(v, (linedef_t *)(picked.ptr));
        }
        else if (!pvstestmode)
        {
            float       centerx, centery;
            vertex_t    v;
            sector_t*   sec;

            switch (picked.type)
            {
            case ot_vertex:
                selected.type = ot_vertex;
                selected.ptr = picked.ptr;
                centerx = ((vertex_t*)(selected.ptr))->x;
                centery = ((vertex_t*)(selected.ptr))->y;
                CalculateOffset(centerx, centery, cursorx, cursory);
                startv = *((vertex_t*)(selected.ptr));
                movemode = TRUE;
                break;

            case ot_line:
                selected.type = ot_line;
                selected.ptr = picked.ptr;
                break;

            case ot_thing:
                selected.type = ot_thing;
                selected.ptr = picked.ptr;
                centerx = ((thing_t*)(selected.ptr))->x;
                centery = ((thing_t*)(selected.ptr))->y;
                CalculateOffset(centerx, centery, cursorx, cursory);
                movemode = TRUE;
                break;

            case ot_none:
                ScreenToWorld(cursorx, cursory, &v);
                sec = PointInSector(v);
                if (sec)
                {
                    selected.type = ot_sector;
                    selected.ptr = sec;
                }
                else
                    selected.type = ot_none;
                break;
            }
        }
        InvalidateRect(hwnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_LBUTTONUP:
        if (movemode)
        {
            if (selected.type == ot_vertex)
            {
                if (!CheckVertex((vertex_t*)selected.ptr))
                    *((vertex_t*)(selected.ptr)) = startv;
            }
            movemode = FALSE;
            InvalidateRect(hwnd, NULL, FALSE);
            UpdateStatusBar();
            return 0;
        }
        break;

    case WM_RBUTTONDOWN:
        if (secdrawmode)
        {
            LS_DecrementVertex();
            InvalidateRect(hwnd, NULL, FALSE);
            UpdateStatusBar();
            return 0;
        }
        selected.type = ot_none;
        InvalidateRect(hwnd, NULL, FALSE);
        pt.x = LOWORD(lParam);
        pt.y = HIWORD(lParam);
        ClientToScreen(hwnd, &pt);
        TrackPopupMenu(hThingMenu, TPM_RIGHTBUTTON, pt.x, pt.y, 0, hwnd, NULL);
        return 0;

    case WM_COMMAND:
        ScreenToClient(hwnd, &pt);
        AddThing(LOWORD(wParam), pt.x, pt.y);
        InvalidateRect(hwnd, NULL, FALSE);
        UpdateStatusBar();
        return 0;

    case WM_MOUSEMOVE:
        cursorx = LOWORD(lParam);
        cursory = HIWORD(lParam);
        if (secdrawmode)
        {
            PickObjectsUnderCursor(cursorx, cursory);
            LS_MoveVertex(cursorx, cursory);
            InvalidateRect(hwnd, NULL, FALSE);
        }
        else if (insvertmode)
        {
            PickObjectsUnderCursor(cursorx, cursory);
            InvalidateRect(hwnd, NULL, FALSE);
        }
        else if (movemode && (wParam&MK_LBUTTON)/*APIoCu2 p743 \11-38 Q*/)
        {
            switch (selected.type)
            {
            case ot_vertex:
                MoveVertex((vertex_t*)selected.ptr, cursorx, cursory);
                break;

            case ot_thing:
                MoveThing((thing_t*)selected.ptr, cursorx, cursory);
                break;
            }
            InvalidateRect(hwnd, NULL, FALSE);
            UpdateStatusBar();
        }
        return 0;

    case WM_DESTROY: // eEBhEjΎɎqEBhEɂ(Windows95 APIoCu2 p725Q)
        CleanupGL();
        return 0;
    }

    return DefWindowProc(hwnd, message, wParam, lParam);
}

void InitThingMenu(void)
{
    int         i, j;
    byte*       pal_p;
    PBITMAPINFO lpbmi;
    HMENU       hPopup1, hPopup2;
    void*       pBits = NULL;
    HBITMAP     hBitmap;

    pbmi = (PBITMAPINFO)malloc(sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    pbmi->bmiHeader.biSize = 40;
    pbmi->bmiHeader.biPlanes = 1;
    pbmi->bmiHeader.biBitCount = 8;
    pbmi->bmiHeader.biCompression = 0;
    pbmi->bmiHeader.biSizeImage = 0;
    pbmi->bmiHeader.biXPelsPerMeter = 0;
    pbmi->bmiHeader.biYPelsPerMeter = 0;
    pbmi->bmiHeader.biClrUsed = 0;
    pbmi->bmiHeader.biClrImportant = 0;

    pal_p = doompal;
    for (i=0; i<256; i++)
    {
        pbmi->bmiColors[i].rgbRed = *pal_p++;
        pbmi->bmiColors[i].rgbGreen = *pal_p++;
        pbmi->bmiColors[i].rgbBlue = *pal_p++;
        pbmi->bmiColors[i].rgbReserved = 0;
    }

    pbmi2 = (PBITMAPINFO)malloc(sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    pbmi3 = (PBITMAPINFO)malloc(sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    pbmi4 = (PBITMAPINFO)malloc(sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    pbmi5 = (PBITMAPINFO)malloc(sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    memcpy(pbmi2, pbmi, sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    memcpy(pbmi3, pbmi, sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    memcpy(pbmi4, pbmi, sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));
    memcpy(pbmi5, pbmi, sizeof(BITMAPINFO) + 255*sizeof(RGBQUAD));

    // DOOM\[X R_InitTranslationTables()[r_draw.c] Q
    for (i=0x70 ; i<0x80 ; i++)
    {
        pbmi2->bmiColors[i].rgbRed      = pbmi->bmiColors[0x60+(i&0xf)].rgbRed;
        pbmi2->bmiColors[i].rgbGreen    = pbmi->bmiColors[0x60+(i&0xf)].rgbGreen;
        pbmi2->bmiColors[i].rgbBlue     = pbmi->bmiColors[0x60+(i&0xf)].rgbBlue;

        pbmi3->bmiColors[i].rgbRed      = pbmi->bmiColors[0x40+(i&0xf)].rgbRed;
        pbmi3->bmiColors[i].rgbGreen    = pbmi->bmiColors[0x40+(i&0xf)].rgbGreen;
        pbmi3->bmiColors[i].rgbBlue     = pbmi->bmiColors[0x40+(i&0xf)].rgbBlue;

        pbmi4->bmiColors[i].rgbRed      = pbmi->bmiColors[0x20+(i&0xf)].rgbRed;
        pbmi4->bmiColors[i].rgbGreen    = pbmi->bmiColors[0x20+(i&0xf)].rgbGreen;
        pbmi4->bmiColors[i].rgbBlue     = pbmi->bmiColors[0x20+(i&0xf)].rgbBlue;
    }

    for (i=0 ; i<256 ; i++)
    {
        pbmi5->bmiColors[i].rgbRed      = (pbmi->bmiColors[i].rgbRed)>>1;
        pbmi5->bmiColors[i].rgbGreen    = (pbmi->bmiColors[i].rgbGreen)>>1;
        pbmi5->bmiColors[i].rgbBlue     = (pbmi->bmiColors[i].rgbBlue)>>1;
    }

    hThingMenu = CreatePopupMenu();
    for (i=0 ; i<NUMTGROUPS ; i++)
    {
        hPopup1 = CreatePopupMenu();
        for (j=0 ; j<numthingdefs ; j++)
        {
            if (thingdefs[j].group == i)
            {
                if (thingdefs[j].spritedata)
                {
                    switch (thingdefs[j].type)
                    {
                    case 2:
                        lpbmi = pbmi2;
                        break;
                    case 3:
                        lpbmi = pbmi3;
                        break;
                    case 4:
                        lpbmi = pbmi4;
                        break;
                    case 58:
                        lpbmi = pbmi5;
                        break;
                    default:
                        lpbmi = pbmi;
                     }
                    PatchToBitmap(thingdefs[j].spritedata, lpbmi, &pBits);
                    hBitmap = CreateDIBitmap(GetDC(hMainWnd), &lpbmi->bmiHeader, CBM_INIT, pBits, lpbmi, DIB_RGB_COLORS);
                    hPopup2 = CreatePopupMenu();
                    AppendMenu(hPopup2, MF_BITMAP, j, (LPCTSTR)hBitmap);
                    AppendMenu(hPopup1, MF_POPUP, (UINT)hPopup2, thingdefs[j].description);
                    free(pBits);
                }
                else
                {
                    AppendMenu(hPopup1, MF_STRING, j, thingdefs[j].description);
                }
            }
        }
        AppendMenu(hThingMenu, MF_POPUP, (UINT)hPopup1, tgroupnames[i]);
    }

    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hMainWnd;
    ofn.lpstrFilter = szFilter;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = 1024;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFileTitle = 256;
    ofn.lpstrDefExt = szDefExt;
    ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
}

void UpdateStatusBar(void)
{
    char        buf[256];
    int         n;
    vertex_t*   v;
    linedef_t*  line;
    sector_t*   sec;
    thing_t*    thing;

    if (pvstestmode)
        sprintf(buf, " PVSeXg[h");
    else if (secdrawmode)
        sprintf(buf, " ZN^[`惂[h");
    else if (insvertmode)
        sprintf(buf, " Vertex }[h");
    else
    {
        n = sprintf(buf, " IIuWFNg: ");
        switch (selected.type)
        {
        case ot_none:
            sprintf(buf + n, "");
            break;
        case ot_vertex:
            v = (vertex_t*)selected.ptr;
            sprintf(buf + n, "Vertex  X %d Y%d", (int)v->x, (int)v->y);
            break;
        case ot_line:
            line = (linedef_t*)selected.ptr;
            n += sprintf(buf + n, "Linedef  Flags: ");
            if (line->flags & ML_BLOCKING)
                n += sprintf(buf + n, "IM ");
            if (line->flags & ML_BLOCKMONSTERS)
                n += sprintf(buf + n, "BM ");
            if (line->flags & ML_TWOSIDED)
                n += sprintf(buf + n, "TS ");
            if (line->flags & ML_DONTPEGTOP)
                n += sprintf(buf + n, "UU ");
            if (line->flags & ML_DONTPEGBOTTOM)
                n += sprintf(buf + n, "LU ");
            if (line->flags & ML_SECRET)
                n += sprintf(buf + n, "SE ");
            if (line->flags & ML_SOUNDBLOCK)
                n += sprintf(buf + n, "BS ");
            if (line->flags & ML_DONTDRAW)
                n += sprintf(buf + n, "NA ");
            if (line->flags & ML_MAPPED)
                n += sprintf(buf + n, "AA ");
            if (!line->flags)
                n += sprintf(buf + n, "none ");
            sprintf(buf + n, " Special: %s  Tag: %d", linespecnames[line->special], line->tag);
            break;
        case ot_sector:
            sec = (sector_t*)selected.ptr;
            sprintf(buf + n, "Sector  Floor: %d  Ceiling: %d  Light: %d  Special: %s  Tag: %d",
                    sec->floorheight, sec->ceilingheight, sec->lightlevel, secspecnames[sec->special], sec->tag);
            break;
        case ot_thing:
            thing = (thing_t*)selected.ptr;
            n += sprintf(buf + n, "Thing (%s)  Angle: %d  Options: ", thingdefs[thing->id].description, thing->angle);
            if (thing->options & 1)
                n += sprintf(buf + n, "1/2 ");
            if (thing->options & 2)
                n += sprintf(buf + n, "3 ");
            if (thing->options & 4)
                n += sprintf(buf + n, "4/5 ");
            if (thing->options & 8)
                n += sprintf(buf + n, "deaf ");
            if (thing->options & 16)
                sprintf(buf + n, "net");
            if (!thing->options)
                sprintf(buf + n, "none");
            break;
        }
    }
    if (savemessage)
    {
        sprintf(buf, " ۑ܂");
        savemessage = FALSE;
    }
    if (buildmessage)
    {
        sprintf(buf, " rh܂");
        buildmessage = FALSE;
    }
    SendMessage(hStatusBar, SB_SETTEXT, 0, (LPARAM)buf);
    sprintf(buf, " Center: X %d Y %d", (int)viewx, (int)viewy);
    SendMessage(hStatusBar, SB_SETTEXT, 1, (LPARAM)buf);
    sprintf(buf, " Scale: %.03f", viewscale);
    SendMessage(hStatusBar, SB_SETTEXT, 2, (LPARAM)buf);
    sprintf(buf, " Sectors: %d  Linedefs: %d  Vertices: %d  Things: %d", numsectors, numlinedefs, numvertices, numthings);
    SendMessage(hStatusBar, SB_SETTEXT, 3, (LPARAM)buf);
}

void UpdateTitleBar(void)
{
    char    title[256] = "WadCraft - [";
    char*   scan;

    scan = mapfilename+strlen(mapfilename)-1;
    while (*scan != '\\' && scan != mapfilename)
        scan--;
    if (scan != mapfilename)
        scan++;
    strcat(title, scan);
    if (mapalterd)
        strcat(title, " * - ");
    else
        strcat(title, " - ");
    strcat(title, mapnames[gamemap-1]);
    strcat(title, "]");
    SetWindowText(hMainWnd, title);
}

typedef struct
{
    char*   name;
    void*   location;
    int     type;   // 0=string, 1=int, 2=float
    char*   defstring;
    int     defintval;
    float   deffloatval;
} default_t;

default_t   defaults[] =
{
    {   "gamefile",     gamefilename,   0,  "undesignated"      },
    {   "playoption1",  &nomonsters,    1,  0,              0   },
    {   "playoption2",  &nomusic,       1,  0,              0   },
    {   "playoption3",  fileoptparms,   0,  "undesignated"      },
    {   "playoption4",  cmdlineparms,   0,  "undesignated"      },
    {   "buildoption1", &calcpvs,       1,  0,              0   },
    {   "buildoption2", &debugout,      1,  0,              0   }
};

void LoadConfig(void)
{
    int     i;
    FILE*   fp;
    char    name[64];
    char    strparm[1024];

    numdefaults = sizeof(defaults)/sizeof(defaults[0]);
    for (i=0 ; i<numdefaults ; i++)
    {
        switch (defaults[i].type)
        {
        case 0:
            strcpy((char*)defaults[i].location, defaults[i].defstring);
            break;
        case 1:
            *((int*)defaults[i].location) = defaults[i].defintval;
            break;
        case 2:
            *((float*)defaults[i].location) = defaults[i].deffloatval;
            break;
        }
    }

    fp = fopen(configfile, "r");
    if (fp)
    {
        while (!feof(fp))
        {
            if (fscanf(fp, "%63s %[^\n]\n", name, strparm) == 2)
            {
                for (i=0 ; i<numdefaults ; i++)
                {
                    if (!strcmp(name, defaults[i].name))
                    {
                        switch (defaults[i].type)
                        {
                        case 0:
                            strcpy((char*)defaults[i].location, strparm);
                            break;
                        case 1:
                            sscanf(strparm, "%d", (int*)defaults[i].location);
                            break;
                        case 2:
                            sscanf(strparm, "%f", (float*)defaults[i].location);
                            break;
                        }
                    }
                }
            }
        }

        fclose(fp);
    }
}

void SaveConfig(void)
{
    int     i;
    FILE*   fp;

    fp = fopen(configfile, "w");
    if (!fp)
        return; // can't write the file, but don't complain

    for (i=0 ; i<numdefaults ; i++)
    {
        switch (defaults[i].type)
        {
        case 0:
            fprintf(fp, "%s\t\t%s\n", defaults[i].name, (char*)defaults[i].location);
            break;
        case 1:
            fprintf(fp, "%s\t\t%d\n", defaults[i].name, *((int*)defaults[i].location));
            break;
        case 2:
            fprintf(fp, "%s\t\t%f\n", defaults[i].name, *((float*)defaults[i].location));
            break;
        }
    }

    fclose(fp);
}

void PlayMap(void)
{
    char*   argv[9];
    int     i=0;
    char*   scan;
    char    currdir[1024];
    char    gamedir[1024];
    char    buf[4];

    if (!strcmp(gamefilename, "undesignated"))
    {
        if (MessageBox(hMainWnd, "Q[̎st@Cw肳Ă܂Bݒ肵܂H", "}bvvC", MB_ICONEXCLAMATION | MB_YESNO) == IDYES)
            SendMessage(hMainWnd, WM_COMMAND, MAKEWPARAM(IDM_GAMELOC, 0), 0);
        else
            return;
    }

    _getcwd(currdir, 1024);

    strcpy(gamedir, gamefilename);
    scan = gamedir+strlen(gamedir)-1;
    while (*scan != '\\')
        scan--;
    *scan = 0;
    _chdir(gamedir);

    scan = gamefilename+strlen(gamefilename)-1;
    while (*scan != '\\')
        scan--;
    scan++;
    argv[i++] = scan; // ŏ̈̓vO

    argv[i++] = "-file";
    if (!strcmp(wadfilename, "untitled.wad"))
    {
        strcpy(wadfilename, currdir);
        strcat(wadfilename, "\\untitled.wad");
    }
    argv[i++] = wadfilename; // pX̒ɋ󔒕̂tH_(e.g. Documents and settings)Ă͂Ȃ
    if (strcmp(fileoptparms, "undesignated"))
        argv[i++] = fileoptparms;

    argv[i++] = "-warp";
    sprintf(buf, "%d", gamemap);
    argv[i++] = buf;

    if (nomonsters)
        argv[i++] = "-nomonsters";

    if (nomusic)
        argv[i++] = "-nomusic";

    if (strcmp(cmdlineparms, "undesignated"))
        argv[i++] = cmdlineparms;

    argv[i] = NULL;

    _spawnv(_P_WAIT, gamefilename, argv);

    _chdir(currdir);
}