#include "thingdef.h"

char* tgroupnames[] =
{
    "Player start",
    "Enemy",
    "Weapon",
    "Ammunition",
    "Power-up",
    "Key",
    "Decoration",
    "Victim",
    //"Non-blocking victim",
    "Corpse",
    "Spot"
};

// Tricks of the DOOM Programming Gurus, Appendix A Q
thingdef_t thingdefs[] =
{
    { 1,    "PLAYA1",   0,  "Player 1 start",           tg_playerstart,     16  },
    { 2,    "PLAYA1",   0,  "Player 2 start",           tg_playerstart,     16  },
    { 3,    "PLAYA1",   0,  "Player 3 start",           tg_playerstart,     16  },
    { 4,    "PLAYA1",   0,  "Player 4 start",           tg_playerstart,     16  },
    { 11,   0,          0,  "Deathmatch start",         tg_playerstart,     16  },

    { 3004, "POSSA1",   0,  "Former Human",             tg_enemy,           20  },
    { 84,   "SSWVA1",   0,  "Wolfenstein SS",           tg_enemy,           20  },
    { 9,    "SPOSA1",   0,  "Former Human Sergeant",    tg_enemy,           20  },
    { 65,   "CPOSA1",   0,  "Former Human Commando",    tg_enemy,           20  },
    { 3001, "TROOA1",   0,  "Imp",                      tg_enemy,           20  },
    { 3002, "SARGA1",   0,  "Demon",                    tg_enemy,           30  },
    { 58,   "SARGA1",   0,  "Spectre",                  tg_enemy,           30  },
    { 3006, "SKULA1",   0,  "Lost Soul",                tg_enemy,           16  },
    { 3005, "HEADA1",   0,  "Cacodemon",                tg_enemy,           31  },
    { 69,   "BOS2A1C1", 0,  "Hell Knight",              tg_enemy,           24  },
    { 3003, "BOSSA1",   0,  "Baron Of Hell",            tg_enemy,           24  },
    { 68,   "BSPIA1D1", 0,  "Arachnotron",              tg_enemy,           64  },
    { 71,   "PAINA1",   0,  "Pain Elemental",           tg_enemy,           31  },
    { 66,   "SKELA1D1", 0,  "Revenant",                 tg_enemy,           20  },
    { 67,   "FATTA1",   0,  "Mancubus",                 tg_enemy,           48  },
    { 64,   "VILEA1D1", 0,  "Arch-Vile",                tg_enemy,           20  },
    { 7,    "SPIDA1D1", 0,  "Spider Mastermind",        tg_enemy,           128 },
    { 16,   "CYBRA1",   0,  "Cyberdemon",               tg_enemy,           40  },
    { 88,   "BBRNA0",   0,  "Boss Brain",               tg_enemy,           16  },

    { 2005, "CSAWA0",   0,  "Chainsaw",                 tg_weapon,          20  },
    { 2001, "SHOTA0",   0,  "Shotgun",                  tg_weapon,          20  },
    { 82,   "SGN2A0",   0,  "Combat shotgun",           tg_weapon,          20  },
    { 2002, "MGUNA0",   0,  "Chaingun",                 tg_weapon,          20  },
    { 2003, "LAUNA0",   0,  "Rocket launcher",          tg_weapon,          20  },
    { 2004, "PLASA0",   0,  "Plasma gun",               tg_weapon,          20  },
    { 2006, "BFUGA0",   0,  "BFG 9000",                 tg_weapon,          20  },

    { 2007, "CLIPA0",   0,  "Ammo clip",                tg_ammunition,      20  },
	{ 2008,	"SHELA0",	0,	"4 Shotgun shells",			tg_ammunition,		20	},
	{ 2010,	"ROCKA0",	0,	"Rocket",					tg_ammunition,		20	},
	{ 2047,	"CELLA0",	0,	"Cell charge",				tg_ammunition,		20	},
	{ 2048,	"AMMOA0",	0,	"Box of Ammo",				tg_ammunition,		20	},
	{ 2049,	"SBOXA0",	0,	"Box of Shells",			tg_ammunition,		20	},
	{ 2046,	"BROKA0",	0,	"Box of Rockets",			tg_ammunition,		20	},
	{ 17,	"CELPA0",	0,	"Cell charge pack",			tg_ammunition,		20	},
	{ 8,	"BPAKA0",	0,	"Backpack",					tg_ammunition,		20	},

    { 2011, "STIMA0",   0,  "Stimpack",                 tg_powerup,         20  },
	{ 2012,	"MEDIA0",	0,	"Medikit",					tg_powerup,         20  },
	{ 2014,	"BON1D0",	0,	"Health Potion",			tg_powerup,         20  },
	{ 2015,	"BON2D0",	0,	"Spiritual Armor",			tg_powerup,         20  },
	{ 2018,	"ARM1A0",	0,	"Security Armor",			tg_powerup,         20  },
	{ 2019,	"ARM2A0",	0,	"Combat Armor",				tg_powerup,         20  },
	{ 83,	"MEGAA0",	0,	"Mega Sphere",				tg_powerup,         20  },
	{ 2013,	"SOULA0",	0,	"Soul Sphere",				tg_powerup,         20  },
	{ 2022,	"PINVA0",	0,	"Invulnerability Artifact", tg_powerup,         20  },
	{ 2023,	"PSTRA0",	0,	"Berserk Pack",				tg_powerup,         20  },
	{ 2024,	"PINSA0",	0,	"Blur Artifact",			tg_powerup,         20  },
	{ 2025,	"SUITA0",	0,	"Radiation Suit",			tg_powerup,         20  },
	{ 2026,	"PMAPA0",	0,	"Computer Map",				tg_powerup,         20  },
	{ 2045,	"PVISA0",	0,	"Light Goggles",			tg_powerup,         20  },

    { 5,    "BKEYA0",   0,  "Blue key-card",            tg_key,             20  },
	{ 13,	"RKEYA0",	0,	"Red key-card",				tg_key,             20  },
	{ 6,	"YKEYA0",	0,	"Yellow key-card",			tg_key,             20  },
	{ 40,	"BSKUA0",	0,	"Blue skull key",			tg_key,             20  },
	{ 38,	"RSKUA0",	0,	"Red skull key",			tg_key,             20  },
	{ 39,	"YSKUA0",	0,	"Yellow skull key",			tg_key,             20  },

    { 2035, "BAR1A0",   0,  "Barrel",                   tg_decoration,      10  },
	{ 70,	"FCANA0",	0,	"Burning barrel",			tg_decoration,		16	},
	{ 30,	"COL1A0",	0,	"Tall green pillar",		tg_decoration,		16	},
	{ 31,	"COL2A0",	0,	"Short green pillar",		tg_decoration,		16	},
	{ 32,	"COL3A0",	0,	"Tall red pillar",			tg_decoration,		16	},
	{ 33,	"COL4A0",	0,	"Short red pillar",			tg_decoration,		16	},
	{ 34,	"CANDA0",	0,	"Candle",					tg_decoration,		16	},
	{ 35,	"CBRAA0",	0,	"Candelabra",				tg_decoration,		16	},
	{ 36,	"COL5A0",	0,	"Short green pillar with heart",tg_decoration,	16	},
	{ 37,	"COL6A0",	0,	"Short red pillar with skull",	tg_decoration,	16	},
	{ 41,	"CEYEA0",	0,	"Evil Eye symbol",			tg_decoration,		16	},
	{ 42,	"FSKUA0",	0,	"Floating Skull",			tg_decoration,		16	},
	{ 43,	"TRE1A0",	0,	"Burnt, gray tree",			tg_decoration,		16	},
	{ 47,	"SMITA0",	0,	"Stalagmite",				tg_decoration,		16	},
	{ 48,	"ELECA0",	0,	"Tall Technocolumn",		tg_decoration,		16	},
    { 54,   "TRE2A0",   0,  "Large brown tree",         tg_decoration,      32  },
	{ 44,	"TBLUA0",	0,	"Tall blue firestick",		tg_decoration,		16	},
	{ 45,	"TGRNA0",	0,	"Tall green firestick",		tg_decoration,		16	},
	{ 46,	"TREDA0",	0,	"Tall red firestick",		tg_decoration,		16	},
	{ 55,	"SMBTA0",	0,	"Short blue firestick",		tg_decoration,		16	},
	{ 56,	"SMGTA0",	0,	"Short green firestick",	tg_decoration,		16	},
	{ 57,	"SMRTA0",	0,	"Short red firestick",		tg_decoration,		16	},
	{ 85,	"TLMPA0",	0,	"Tall technolamp",			tg_decoration,		16	},
	{ 86,	"TLP2A0",	0,	"Short technolamp",			tg_decoration,		16	},
	{ 2028,	"COLUA0",	0,	"Floor lamp",				tg_decoration,		16	},

    { 25,   "POL1A0",   0,  "Impaled human",            tg_victim,          16  },
    { 26,   "POL6A0",   0,  "Twitching, impaled human", tg_victim,          16  },
    { 27,   "POL4A0",   0,  "Skull on a pole",          tg_victim,          16  },
    { 28,   "POL2A0",   0,  "5-skull shish-kebab",      tg_victim,          16  },
    { 29,   "POL3A0",   0,  "Pile of skulls and candles",   tg_victim,      16  },
    { 49,   "GOR1A0",   0,  "Hanged victim, twitching", tg_victim,          16  },
    { 63,   "GOR1A0",   0,  "Hanged victim, twitching (NB)",    tg_victim,  16  },
    { 50,   "GOR2A0",   0,  "Suspended victim",         tg_victim,          16  },
    { 59,   "GOR2A0",   0,  "Suspended victim (NB)",    tg_victim,          16  },
    { 51,   "GOR3A0",   0,  "Suspended victim, one-legged", tg_victim,      16  },
    { 61,   "GOR3A0",   0,  "Suspended victim, one-legged (NB)",tg_victim,  16  },
    { 52,   "GOR4A0",   0,  "Hanging pair of legs",     tg_victim,          16  },
    { 60,   "GOR4A0",   0,  "Hanging pair of legs (NB)",tg_victim,          16  },
    { 53,   "GOR5A0",   0,  "Hanging single leg",       tg_victim,          16  },
    { 62,   "GOR5A0",   0,  "Hanging single leg (NB)",  tg_victim,          16  },
    { 73,   "HDB1A0",   0,  "Hanging victim, no guts",  tg_victim,          16  },
    { 74,   "HDB2A0",   0,  "Hanging victim, no guts/brain",    tg_victim,  16  },
    { 75,   "HDB3A0",   0,  "Hanging torso, looking down",  tg_victim,      16  },
    { 76,   "HDB4A0",   0,  "Hanging torso, open skull",    tg_victim,      16  },
    { 77,   "HDB5A0",   0,  "Hanging torso, looking up",    tg_victim,      16  },
    { 78,   "HDB6A0",   0,  "Hanging torso, no brain",  tg_victim,          16  },
    { 72,   "KEENA0",   0,  "Hanging Billy",            tg_victim,          16  },

    { 10,   "PLAYW0",   0,  "Exploded player",          tg_corpse,          16  },
    { 15,   "PLAYN0",   0,  "Dead player",              tg_corpse,          16  },
	{ 18,	"POSSL0",	0,	"Dead Former Human",		tg_corpse,			20	},
    { 19,   "SPOSL0",   0,  "Dead Former Human Sergeant",   tg_corpse,      20  },
	{ 20,	"TROOM0",	0,	"Dead Imp",					tg_corpse,			20	},
	{ 21,	"SARGN0",	0,	"Dead Demon",				tg_corpse,			20	},
	{ 22,	"HEADL0",	0,	"Dead Cacodemon",			tg_corpse,			20	},
	{ 24,	"POL5A0",	0,	"Pool of blood and guts",	tg_corpse,			20	},
	{ 79,	"POB1A0",	0,	"Pool of guts",				tg_corpse,			20	},
	{ 80,	"POB2A0",	0,	"Pool of blood",			tg_corpse,			20	},
	{ 81,	"BRS1A0",	0,	"Pool of brains",			tg_corpse,			20	},

    { 14,   0,          0,  "Teleport landing",         tg_spot,            0   },
    { 89,   0,          0,  "Boss Shooter",             tg_spot,            0   },
    { 87,   0,          0,  "Spawn Spot",               tg_spot,            0   }
};

int GetNumThingdefs(void)
{
    return sizeof(thingdefs)/sizeof(thingdef_t);
}