#include <windows.h>

typedef struct 
{
    char    identification[4]; // Should be "IWAD" or "PWAD".
    int     numlumps;
    int     infotableofs;
} wadinfo_t;

typedef struct 
{
    int     filepos;
    int     size;
    char    name[8];
} lumpinfo_t;

typedef struct 
{
    short   originx;    // x offset from top-left corner of texture space to start placement of this patch (UDS[8-4]甲)
    short   originy;    // y offset
    short   patch;
    short   stepdir;
    short   colormap;
} patchdesc_t;

typedef struct 
{
    char        name[8];
    long        dummy1;	
    short       width;
    short       height;
    long        dummy2;
    short       patchcount;
    patchdesc_t patches[1];
} maptexture_t;

typedef struct 
{
    short   width;        
    short   height;
    short   leftoffset;   
    short   topoffset;   
    int     columnofs[1];   // columnofs[width]
} patch_t;

typedef struct 
{
    byte topdelta;  // 0xFF ends the column
    byte length;   
} post_t;

BOOL LoadWadFile(char* filename);
void PatchToBitmap(patch_t* patch, PBITMAPINFO lpbmi, void** ppBits);
void TextureToBitmap(maptexture_t* texture, PBITMAPINFO lpbmi, void** ppBits);
int GetTextureNumForName(char* name);
char* GetTextureNameForNum(int i);
int GetFlatNumForName(char* name);

extern byte* doompal;
extern int numtextures;
extern maptexture_t** textures;
extern int numflats;
extern void** flats;
extern char** flatnames;
extern int numthingdefs;