#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include <stdio.h>
#include "map.h"
#include "sysutils.h"
#include "sysmain.h"

int     savecount = 0;
int     gamemap = 1;
char    mapfilename[1024] = "untitled.wcm";
char    wadfilename[1024] = "untitled.wad";

void ChangeMapName(char* name)
{
    strcpy(mapfilename, name);
    strcpy(wadfilename, name);
    strcpy(&wadfilename[strlen(wadfilename)-3], "wad");
}

void SaveMapFile(void)
{
    FILE*       fp;
    char        ID4[5];
    int         i;
    vertex_t*   v;
    sector_t*   sec;
    linedef_t   line, *line_p;
    thing_t*    thing;

    fp = fopen(mapfilename, "wb");
    strcpy(ID4, "WCM ");
    fwrite(ID4, 1, 4, fp);
    fwrite(&gamemap, sizeof(int), 1, fp);
    strcpy(ID4, "VERT");
    fwrite(ID4, 1, 4, fp);
    fwrite(&numvertices, sizeof(int), 1, fp);
    for (v = firstvertex.next, i=0 ; v ; v = v->next, i++)
        fwrite(v, sizeof(vertex_t), 1, fp);
    if (i != numvertices)
        Alert("SaveMapFile: Vertex ̐܂");
    strcpy(ID4, "SCTR");
    fwrite(ID4, 1, 4, fp);
    fwrite(&numsectors, sizeof(int), 1, fp);
    for (sec = firstsector.next, i=0 ; sec ; sec = sec->next, i++)
        fwrite(sec, sizeof(sector_t), 1, fp);
    if (i != numsectors)
        Alert("SaveMapFile: Sector ̐܂");
    strcpy(ID4, "LINE");
    fwrite(ID4, 1, 4, fp);
    fwrite(&numlinedefs, sizeof(int), 1, fp);
    for (line_p = firstlinedef.next, i=0 ; line_p ; line_p = line_p->next, i++)
    {
        line = *line_p;
        line.v1 = (vertex_t*)VertexNumForPtr(line_p->v1);
        line.v2 = (vertex_t*)VertexNumForPtr(line_p->v2);
        line.sides[0].sec = (sector_t*)SectorNumForPtr(line_p->sides[0].sec);
        if (line_p->sides[1].sec)
            line.sides[1].sec = (sector_t*)SectorNumForPtr(line_p->sides[1].sec);
        else
            line.sides[1].sec = (sector_t*)0xFFFFFFFF;
        fwrite(&line, sizeof(linedef_t), 1, fp);
    }
    if (i != numlinedefs)
        Alert("SaveMapFile: Linedef ̐܂");
    strcpy(ID4, "THNG");
    fwrite(ID4, 1, 4, fp);
    fwrite(&numthings, sizeof(int), 1, fp);
    for (thing = firstthing.next, i=0 ; thing ; thing = thing->next, i++)
        fwrite(thing, sizeof(thing_t), 1, fp);
    if (i != numthings)
        Alert("SaveMapFile: Thing ̐܂");
    fclose(fp);

    savecount++;
    mapalterd = FALSE;
    UpdateTitleBar();
}

void LoadMapFile(char* filename)
{
    FILE*       fp;
    char        ID4[4];
    int         i;
    vertex_t*   v;
    sector_t*   sec;
    linedef_t*  line;
    thing_t*    thing;

    ClearMap();

    fp = fopen(filename, "rb");
    if (!fp)
        Error("LoadMapFile: t@CJ܂");
    fread(ID4, 1, 4, fp);
    if (strncmp(ID4, "WCM ", 4))
        Error("LoadMapFile: WCM x܂");
    fread(&gamemap, sizeof(int), 1, fp);
    fread(ID4, 1, 4, fp);
    if (strncmp(ID4, "VERT", 4))
        Error("LoadMapFile: VERT x܂");
    fread(&numvertices, sizeof(int), 1, fp);
    v = &firstvertex;
    for (i=0 ; i<numvertices ; i++)
    {
        v->next = (vertex_t*)malloc(sizeof(vertex_t));
        fread(v->next, sizeof(vertex_t), 1, fp);
        v = v->next;
    }
    if (v->next)
    {
        Alert("Ō Vertex  next tB[h NULL ɂȂĂ܂");
        v->next = NULL;
    }
    fread(ID4, 1, 4, fp);
    if (strncmp(ID4, "SCTR", 4))
        Error("LoadMapFile: SCTR x܂");
    fread(&numsectors, sizeof(int), 1, fp);
    sec = &firstsector;
    for (i=0 ; i<numsectors ; i++)
    {
        sec->next = (sector_t*)malloc(sizeof(sector_t));
        fread(sec->next, sizeof(sector_t), 1, fp);
        sec = sec->next;
    }
    if (sec->next)
    {
        Alert("Ō Sector  next tB[h NULL ɂȂĂ܂");
        sec->next = NULL;
    }
    fread(ID4, 1, 4, fp);
    if (strncmp(ID4, "LINE", 4))
        Error("LoadMapFile: LINE x܂");
    fread(&numlinedefs, sizeof(int), 1, fp);
    line = &firstlinedef;
    for (i=0 ; i<numlinedefs ; i++)
    {
        line->next = (linedef_t*)malloc(sizeof(linedef_t));
        fread(line->next, sizeof(linedef_t), 1, fp);
        line = line->next;
        line->v1 = (vertex_t*)VertexPtrForNum((unsigned int)line->v1);
        line->v2 = (vertex_t*)VertexPtrForNum((unsigned int)line->v2);
        line->sides[0].sec = (sector_t*)SectorPtrForNum((unsigned int)(line->sides[0].sec));
        line->sides[1].sec = (sector_t*)SectorPtrForNum((unsigned int)(line->sides[1].sec)); // Ȃ NULL Ԃ
    }
    if (line->next)
    {
        Alert("Ō Linedef  next tB[h NULL ɂȂĂ܂");
        line->next = NULL;
    }
    fread(ID4, 1, 4, fp);
    if (strncmp(ID4, "THNG", 4))
        Error("LoadMapFile: THNG x܂");
    fread(&numthings, sizeof(int), 1, fp);
    thing = &firstthing;
    for (i=0 ; i<numthings ; i++)
    {
        thing->next = (thing_t*)malloc(sizeof(thing_t));
        fread(thing->next, sizeof(thing_t), 1, fp);
        thing = thing->next;
    }
    if (thing->next)
    {
        Alert("Ō Thing  next tB[h NULL ɂȂĂ܂");
        thing->next = NULL;
    }
    fclose(fp);

    ChangeMapName(filename);
    mapalterd = FALSE;
    UpdateTitleBar();
}